package main;

import java.io.*;
import java.util.*;

import org.apache.commons.math3.linear.RealMatrix;

import kmeans.KMmain;


public class BenUtil {
	
	public static double sum(double[] input){
		double reto=0;
		for(int i=0;i<input.length;i++){
			reto=reto+input[i];
		}
		return reto;
	}
	
	public static double getVariance(double[] input){
        double mean = BenUtil.mean(input);
        double temp = 0;
        for(double a :input)
            temp += (mean-a)*(mean-a);
        return (temp/input.length);
    }
    
	public static double getStdDev(double[] input){
        return Math.sqrt(BenUtil.getVariance(input));
    }
	
	public static double median(double[] input){
		double median=0;
		Arrays.sort(input);
		if((input.length%2==0)){
			double d = (double) ((input[(input.length-1)/2]+input[(input.length+1)/2]))/2;
			median=d;
		} else {
			median = (double)( input[input.length/2] ) ;
		}
		return median;	
	}
	
	public static double mean(double[] input){
		double mean=0;
		for(int i=0;i<input.length;i++){
			mean=mean+input[i];
		}
		double div = (double) (input.length);
		mean=mean/div;
		return mean;	
	}
	public static double mean(ArrayList<double[]> dipvalue) {
		double mean = 0;
		for(int i=0;i<dipvalue.size();i++){
			mean = mean + BenUtil.sum(dipvalue.get(i));
		}
		mean = mean / (dipvalue.size()*dipvalue.get(0).length);
		return mean;
	}
	
	public static void divideMean(ArrayList<double[]> strength) {
		double mean = BenUtil.mean(strength);
		int count = strength.size()*strength.get(0).length;
		for(int i=0;i<strength.size();i++){
			for(int j=0;j<strength.get(i).length;j++){
				strength.get(i)[j]=strength.get(i)[j]/mean;
			}
		}
	}


	public static double meanNMI(double[] input){
		double mean=0;
		double div = input.length;
		//BenUtil.print(input);;
		for(int i=0;i<input.length;i++){
			if(input[i]< 2 ){
				mean=mean+input[i];
				//System.out.println(mean+"  "+input[i]);
			} else {
				div--;
			}
		}
		//System.out.println(mean);
		//System.out.println(div);
		mean=mean/div;
		//System.out.println(mean);
		return mean;	
	}
	
	public static double max(double[] erg) {
		double max = erg[0];
		for(int i=0;i<erg.length;i++){
			if(erg[i]>max){
				max=erg[i];
			}
		}
		return max;
	}
	
	public static double min(double[] values) {
		double min = values[0];
		for(int i=0;i<values.length;i++){
			if(values[i]<min){
				min=values[i];
			}
		}
		return min;
	}
	


	public static Double minArrayList(ArrayList<Double> init) {
		Double min = init.get(0);
		for(int i=0;i<init.size();i++){
			if(init.get(i)<min){
				min=init.get(i);
			}
		}
		return min;
	}
	

	public static Double maxArrayList(ArrayList<Double> init) {
		Double max = init.get(0);
		for(int i=0;i<init.size();i++){
			if(init.get(i)>max){
				max=init.get(i);
			}
		}
		return max;
	}



	public static int min(ArrayList<Integer> init) {
		int min = init.get(0);
		for(int i=0;i<init.size();i++){
			if(init.get(i)<min){
				min=init.get(i);
			}
		}
		return min;
	}

	public static int min(int[] values) {
		int min = values[0];
		for(int i=0;i<values.length;i++){
			if(values[i]<min){
				min=values[i];
			}
		}
		return min;
	}


	public static int max(int[] erg) {
		int max = erg[0];
		for(int i=0;i<erg.length;i++){
			if(erg[i]>max){
				max=erg[i];
			}
		}
		return max;
	}
	

	public static double[] mult(double[] vect, double d) {
		double[] neo = new double[vect.length];
		for(int i=0;i<neo.length;i++){
			neo[i]=vect[i]*d;
		}
		return neo;
	}	

	public static double[] add(double[] a, double[] b){
		for(int i=0;i<a.length;i++){
			a[i]=a[i]+b[i];
		}
		return a;
	}
	
	public static void shiftBy(ArrayList<double[]> punkte, double[] mini) {
		for(int i=0;i<punkte.size();i++){
			double[] now = punkte.get(i);
			now = BenUtil.add(now,mini);
		}
	}

	
	public static double[] substract(double[] a, double[] b){
		double[] reto = new double[a.length];
		for(int i=0;i<a.length;i++){
			reto[i]=a[i]-b[i];
		}
		return reto;
	}
	
	
	// berechnet die Wahrscheinlichkeit eines punktes unter normalverteilung, bei bekannter distanz und standardabweichung.
	public static double pdf(double dist,double dev){
		double reto=0;
		//1/((2 pi)^(1/2)) ca 0.398942
		reto=0.398942*(1/dev)*Math.exp(-(dist*dist)/(2*dev*dev));
		return reto;
	}
	
	public static double norm(double[] a){
		double norm=0;
		for(int i=0;i<a.length;i++){
			norm=norm+(a[i]*a[i]);
		}
		norm=Math.sqrt(norm);
		return norm;
	}
	
	public static double[] normalize(double[] a){
		double norm = BenUtil.norm(a);
		for(int i=0;i<a.length;i++){
			a[i]=a[i]/norm;
		}
		return a;
	}
	
	
	public static double normsquared(double[] a){
		double norm=0;
		for(int i=0;i<a.length;i++){
			norm=norm+(a[i]*a[i]);
		}
		return norm;
	}
	
	/*
	 * berechnet die distanz zwischen zwei punkte. Euklid distanz.
	 */
	public static double dist(double[] a, double[] b){
		double dist=0;
		for(int i=0;i<a.length;i++){
			dist=dist+(a[i]-b[i])*(a[i]-b[i]);
		}
		dist = Math.sqrt(dist);
		return dist;
	}
	

	public static double[] dist(double[] now, ArrayList<double[]> center) {
		double[] reto = new double[center.size()];
		for(int i=0;i<center.size();i++){
			reto[i] = BenUtil.dist(now, center.get(i));
		}
		return reto;
	}
	
	public static double dist(double[] a, double[] b, double[] var) {
		double dist=0;
		for(int i=0;i<a.length;i++){
			dist=dist+var[i]*(a[i]-b[i])*(a[i]-b[i]);
		}
		dist = Math.sqrt(dist);
		return dist;
	}
	

	
	public static int minDist(double[] now, ArrayList<double[]> center) {
		int reto=0;
		double dist = BenUtil.dist(now, center.get(0));
		for(int i=0;i<center.size();i++){
			double di=BenUtil.dist(now, center.get(i));
			if(di<dist){
				dist=di;
				reto=i;
			}
		}
		return reto;
	}
	
	public static double computeSSE(DipKM thea, int[] lab,double[][] center){
			double SSE=0;
			for(int i=0;i<thea.getDatapoints().size();i++){
				int label = lab[i];
				double[] localCent = center[label];
				SSE = SSE + BenUtil.normsquared(localCent,thea.getDatapoints().get(i));
			}			
			return SSE;
	}
	
	public static double normsquared(double[] localCent, double[] ds) {
		double norm=0;
		for(int i=0;i<ds.length;i++){
			double aa = Math.abs(localCent[i]-ds[i]);
			norm=norm+(aa*aa);
		}
		return norm;
	}

	public static int[] readLabelCSV(String s) throws Exception {
		ArrayList<Integer> label = new ArrayList<Integer>(); 
		FileReader fr = new FileReader("./label/"+s+".csv");
	    @SuppressWarnings("resource")
		BufferedReader br = new BufferedReader(fr);
	    String input = br.readLine();
	    while(input!=null){
	    	label.add(Integer.parseInt(input));
	    	//System.out.println(input);
		    input=br.readLine();
	    }
	    int[] reto = new int[label.size()];
	    for(int i=0;i<reto.length;i++){
	    	reto[i]=label.get(i);
	    }
	    int min = BenUtil.min(reto);
	    for(int i=0;i<reto.length;i++){
	    	reto[i]=reto[i]-min+1;
	    }
		return reto;
	}

	public static int[] readLabelSubKMeansDat(String string) throws Exception {
		ArrayList<Integer> label = new ArrayList<Integer>(); 
		FileReader fr = new FileReader("./label/"+string+".dat");
	    @SuppressWarnings("resource")
		BufferedReader br = new BufferedReader(fr);
	    String input = br.readLine();
	    
	    while(input!=null){
	    	input = input.substring(0,input.indexOf(";"));
	    	//System.out.println(input);
	    	label.add(Integer.parseInt(input));
	    	//System.out.println(input);
		    input=br.readLine();
	    }
	    int[] reto = new int[label.size()];
	    for(int i=0;i<reto.length;i++){
	    	reto[i]=label.get(i);
	    }
		return reto;
	}
	
	
	
	
	public static ArrayList<double[]> readBlind(String s, ArrayList<Integer> init) throws IOException {
		ArrayList<double[]> data = new ArrayList<double[]>();
		FileReader fr = new FileReader("./dataset/"+s+".txt");
	    @SuppressWarnings("resource")
		BufferedReader br = new BufferedReader(fr);
	    String input = br.readLine();
	    input=input.replace(" ", "");
	    input=input.replace("	", "");
	    input=input.replace("\"", "");
		String[] tokens = input.split(",");
		
		int dim = tokens.length-1;

	    while(input!=null){
		    input=input.replace(" ", "");
		    input=input.replace("	", "");
		    input=input.replace("\"", "");
			tokens = input.split(",");
			double[] add = new double[dim];
			
	    	for(int i=0;i<dim;i++){
	    		add[i]=Double.parseDouble(tokens[i]);
	    	}
	    	init.add(Integer.parseInt(tokens[dim]));
	    	//add[dim]=Integer.parseInt(tokens[dim]);
	    	data.add(add);
		    input=br.readLine();
	    }
	    return data;
	}
	
	public static void read(DipKM Sphere, String s) throws IOException{
		ArrayList<Integer> init = new ArrayList<Integer>();
		ArrayList<double[]> data = BenUtil.readBlind(s, init);
		int min = BenUtil.min(init);
		for(int i=0;i<data.size();i++){
			Sphere.addClusterIndex(data.get(i), (init.get(i)-min));
		}
		Sphere.setDimension(data.get(0).length);
	}
	
	public static void read2(DipKM Sphere, String s) throws IOException{
		ArrayList<Integer> init = new ArrayList<Integer>();
		ArrayList<double[]> data = BenUtil.readBlind(s, init);
		for(int i=0;i<data.size();i++){
			Sphere.addClusterIndex(data.get(i), 0);
		}
		Sphere.setDimension(data.get(0).length);
	}

	
	public static int getK(String dataSet) throws Exception {
		ArrayList<Integer> init = new ArrayList<Integer>();
		ArrayList<double[]> data = BenUtil.readBlind(dataSet, init);

		int reto=1;
		ArrayList<Integer> unique = new ArrayList<Integer>();
		for(int i=0;i<init.size();i++){
			int a = init.get(i);
			if(unique.contains(a)==false){
				unique.add(a);
			}
		}
		reto = unique.size();
		return reto;
	}
	
	public static int[] countplus(int[] goal, int[] counter){
		int i=counter.length-1;
		
		while(counter[i]>=goal[i]){
			i--;
		} 
		counter[i]++;
		
		for(int j=i+1;j<counter.length;j++){
			counter[j]=counter[j-1]+1;
		}
		return counter;
	}
	
	public static int[][] allSubsets(int dim){
		
		int all = 0;
		for(int i=0;i<dim;i++){
			int max = BenUtil.pascal(dim, i+1);
			all=all+max;
		}
		int[][] al  = new int[all][dim];
		
		int cc=0;
		
		for(int i=0;i<dim;i++){
			int a=dim;
			int b = i+1;
			int[] goal = new int[b];
			int step = a;
			for(int i1=goal.length-1;i1>=0;i1--){
				goal[i1]=step;
				step--;
			}
			int[] counter = new int[b];
			for(int i1=0;i1<counter.length;i1++){
				counter[i1]=i1+1;
			}
			int max = BenUtil.pascal(a, b)-1;
			//BenUtil.print(counter);
			al[cc]=Arrays.copyOf(counter, counter.length);
			cc++;
			for(int i1=0;i1<max;i1++){
				BenUtil.countplus(goal,counter);
				//BenUtil.print(counter);
				al[cc]=Arrays.copyOf(counter, counter.length);
				cc++;
			}
		}
		return al;
	}
	
	public static void subset(int a, int b) {
		int[] goal = new int[b];
		int step = a;
		for(int i=goal.length-1;i>=0;i--){
			goal[i]=step;
			step--;
		}
		int[] counter = new int[b];
		for(int i=0;i<counter.length;i++){
			counter[i]=i+1;
		}
		int max = BenUtil.pascal(a, b)-1;
		BenUtil.print(counter);
		for(int i=0;i<max;i++){
			BenUtil.countplus(goal,counter);
			BenUtil.print(counter);
		}
	}
	
	public static int pascal(int i, int j) {
		double reto=1;
		int step=i-j;
		for(int k=0;k<step;k++){
			reto=reto*i;
			i--;
		}
		for(int k=1;k<=step;k++){
			reto=reto/k;
			j--;
		}
		return (int)(reto);
	}
	
	public static double dot(double[] v, double[] w){
		double reto = 0;
		for(int i=0;i<v.length;i++){
			reto = reto + v[i]*w[i];
		}
		return reto;
	}
	
	
	/*
	 * hopefully NMI
	 * @author Ben I.
	 */
	public static double NMI(ArrayList<Integer> one, ArrayList<Integer> two){
		if(one.size()!=two.size()){
			throw new IllegalArgumentException("Sizes don't match!");
		}
		int maxone = Collections.max(one);
		int maxtwo = Collections.max(two);
	
		double[][] count = new double[maxone+1][maxtwo+1];
		//System.out.println(count[1][2]);
		for(int i=0;i<one.size();i++){
			count[one.get(i)][two.get(i)]++;
		}
		//i<maxone=R
		//j<maxtwo=C
		double[] bj = new double[maxtwo+1];
		double[] ai = new double[maxone+1];
		
		for(int m=0;m<(maxtwo+1);m++){
			for(int l=0;l<(maxone+1);l++){
				bj[m]=bj[m]+count[l][m];
			}
		}
		for(int m=0;m<(maxone+1);m++){
			for(int l=0;l<(maxtwo+1);l++){
				ai[m]=ai[m]+count[m][l];
			}
		}
		
		double N=0;
		for(int i=0;i<ai.length;i++){
			N=N+ai[i];
		}
		double HU = 0;
		for(int l=0;l<ai.length;l++){
			double c=0;
			c=(ai[l]/N);
			if(c>0){
				HU=HU-c*Math.log(c);
			}
		}
		
		double HV = 0;
		for(int l=0;l<bj.length;l++){
			double c=0;
			c=(bj[l]/N);
			if(c>0){
				HV=HV-c*Math.log(c);
			}
		}
		double HUstrichV=0;
		for(int i=0;i<(maxone+1);i++){
			for(int j=0;j<(maxtwo+1);j++){
				if(count[i][j]>0){
					HUstrichV=HUstrichV-count[i][j]/N*Math.log(((count[i][j])/(bj[j])));
				}
			}
		}
		double IUV = HU-HUstrichV; 
		double reto = IUV/(Math.max(HU, HV));
		
		return reto;
	}
	
	public static double[] getProjection(ArrayList<double[]> data, double[] direction) {
		double[] proj = new double[data.size()];
		for(int i=0;i<proj.length;i++){
			proj[i] = BenUtil.dot(direction, data.get(i));
		}
		return proj;
	}


	public static void printLine(ArrayList<Double> nmi) {
		System.out.print("a={");
		for(int i=0;i<nmi.size()-1;i++){
			System.out.printf("%.3f, ",nmi.get(i));
		}
		System.out.printf("%.3f}; ",nmi.get(nmi.size()-1));
		System.out.println();
	}	

	public static void print(double[][] te) {
		for(int i=0;i<te.length;i++){
			BenUtil.print(te[i]);
		}
	}
	
	public static void printMathematica(double[] boo) {
		System.out.print("a={");
		for(int i=0;i<boo.length-1;i++){
			System.out.printf("%.4f, ",boo[i]);
		}
		System.out.printf("%.4f}; ",boo[boo.length-1]);
		System.out.println();
	}
	
	public static void print(double[] boo){
		for(int i=0;i<boo.length-1;i++){
			System.out.printf("%.4f ",boo[i]);
		}
		System.out.printf("%.4f ",boo[boo.length-1]);
		System.out.println();
	}
	
	public static void print(int[] boo) {
		for(int i=0;i<boo.length-1;i++){
			System.out.print(boo[i]+", ");
		}
		System.out.println(boo[boo.length-1]);
	}
	
	public static void print(ArrayList<double[]> poss) {
		for(int k=0;k<poss.size();k++){
			System.out.print("double[] a"+k+"={");
			double[] boo = poss.get(k);
			for(int i=0;i<boo.length-1;i++){
				System.out.printf("%.2f,",boo[i]);
			}
			System.out.printf("%.2f",boo[boo.length-1]);
			System.out.println("};");
		}
	}

	public static void printArrDouArr(ArrayList<double[]> poss) {
		BenUtil.print(poss);
	}	
	
	public static void printArrIntArr(ArrayList<int[]> poss) {
		for(int k=0;k<poss.size();k++){
			System.out.print("double[] a"+k+"={");
			int[] boo = poss.get(k);
			for(int i=0;i<boo.length-1;i++){
				System.out.print(boo[i]+", ");
			}
			System.out.println(boo[boo.length-1]);
			System.out.println("};");
		}
	}	
	

	public static void printArrInt(ArrayList<Integer> indices) {
		for(int i=0;i<indices.size();i++){
			System.out.print(indices.get(i)+", ");
		}
		System.out.println();
	}

	
	public static void printArrDou(ArrayList<Double> clusters) {
		for(int i=0;i<clusters.size();i++){
			System.out.printf("%.2f,",clusters.get(i));
		}
		System.out.println();
	}

	public static void printLine(double[] boo) {
		for(int i=0;i<boo.length-1;i++){
			System.out.printf("%.0f, ",boo[i]);
			//System.out.println();
		}
		System.out.printf("%.0f",boo[boo.length-1]);
		System.out.println();
	}

	
	public static double NMI(DipKM theo, DipKM thea) {
		return BenUtil.NMI(theo.association(), thea.association());
	}

	public static double NMI(int[] indi, int[] association) {
		ArrayList<Integer> one = new ArrayList<Integer>();
		ArrayList<Integer> two = new ArrayList<Integer>();
		
		for(int i=0;i<indi.length;i++){
			one.add(indi[i]+1);
			two.add(association[i]+1);
		}
		double reto = BenUtil.NMI(one, two);
		return reto;
	}

	public static int IndexMax(double[] scale) {
		int reto = 0;
		double max = scale[0];
		for(int i=0;i<scale.length;i++){
			if(scale[i]>max){
				max=scale[i];
				reto=i;
			}
		}
		return reto;
	}

	public static int IndexMin(double[] scale) {
		int reto = 0;
		double min = scale[0];
		for(int i=0;i<scale.length;i++){
			if(scale[i]<min){
				min = scale[i];
				reto=i;
			}
		}
		return reto;
	}
	

	public static int unique(int[] label) {
		ArrayList<Integer> uni = new ArrayList<Integer>();
		for(int i=0;i<label.length;i++){
			if(uni.contains(label[i])){
				
			} else {
				uni.add(label[i]);
			}
		}
		return uni.size();
	}
	


	
	
	/*public static void saveNMI(LWC theo, LWC thea) throws IOException {
		ArrayList<Integer> one = new ArrayList<Integer>();
		ArrayList<Integer> two = new ArrayList<Integer>();
		
		//double[] a = theo.getData().get(0);
		for(int i=0;i<theo.getData().size();i++){
			double[] a = theo.getData().get(i);
			one.add(0);
			two.add(thea.getID(a));
		}
		
		for(int i=0;i<theo.getCluster().size();i++){
			for(int j=0;j<theo.getCluster().get(i).size();j++){
				double[] a = theo.getCluster().get(i).get(j);
				one.add(i);
				two.add(thea.getID(a));
			}
		}
		
		FileWriter fw = new FileWriter("nmi1.txt");
		FileWriter fw2 = new FileWriter("nmi2.txt");
        BufferedWriter bw = new BufferedWriter(fw);
        BufferedWriter bw2 = new BufferedWriter(fw2);

		for(int i=0;i<one.size();i++){
			int wr = (one.get(i)+1);
			bw.write(wr+" ");
			bw.newLine();
			bw.flush();
		}
		bw.close();
		
		for(int i=0;i<two.size();i++){
			int wr = (two.get(i)+1);
			bw2.write(wr+" ");
			bw2.newLine();
			bw2.flush();
		}
		bw2.close();
	}*/

	public static void save(DipKM theo, int[] assoc, String s) throws IOException {
		FileWriter fw = new FileWriter(s+".txt");
        BufferedWriter bw = new BufferedWriter(fw);
        ArrayList<double[]> data = theo.getDatapoints();
        //int[] assoc = theo.association();
		int dim = theo.getDimension();
		for(int i=0;i<data.size();i++){
			for(int j=0;j<dim;j++){
				bw.write(data.get(i)[j]+", ");
			}	
			bw.write((assoc[i])+"");
			bw.newLine();
			bw.flush();
		}
		bw.close();
	}
	
	public static void save(ArrayList<double[]> dat, String s) throws IOException {
		FileWriter fw = new FileWriter(s+".txt");
        BufferedWriter bw = new BufferedWriter(fw);

		int dim = dat.get(0).length;
		for(int i=0;i<dat.size();i++){
			for(int j=0;j<dim-1;j++){
				bw.write(dat.get(i)[j]+", ");
			}	
			bw.write(dat.get(i)[dim-1]+"");
			bw.newLine();
			bw.flush();
		}
		bw.close();
	}
	
	
	public static void saveNoLabels(DipKM theo, String s) throws IOException {
		FileWriter fw = new FileWriter(s+".txt");
        BufferedWriter bw = new BufferedWriter(fw);
        ArrayList<double[]> data = theo.getDatapoints();
        int[] assoc = theo.association();
		int dim = theo.getDimension();
		for(int i=0;i<data.size();i++){
			for(int j=0;j<dim-1;j++){
				bw.write(data.get(i)[j]+", ");
			}	
			bw.write(data.get(i)[dim-1]+"");
			bw.newLine();
			bw.flush();
		}
		bw.close();
	}

	public static void saveArff(DipKM theo,int[] assoc, String s) throws IOException {
		FileWriter fw = new FileWriter(s+".arff");
        BufferedWriter bw = new BufferedWriter(fw);
        ArrayList<double[]> data = theo.getDatapoints();
		int dim = theo.getDimension();
		
		s = s.replace(" ", "");
		
		bw.write("@RELATION "+s.substring(2));
		bw.newLine();
		bw.newLine();
		
		for(int i=0;i<dim;i++){
			bw.write("@ATTRIBUTE a"+i);
			bw.write("	NUMERIC");
			bw.newLine();
			bw.flush();
		}
		bw.write("@ATTRIBUTE class	");
		bw.write("{");
		
		for(int i=0;i<theo.getKcluster()-1;i++){
			bw.write("c"+(i)+",");
		}
		bw.write("c"+(theo.getKcluster()-1)+"}");
		bw.newLine();
		bw.newLine();
		bw.write("@DATA");
		bw.newLine();
		
		for(int i=0;i<data.size();i++){
			for(int j=0;j<dim;j++){
				bw.write(data.get(i)[j]+", ");
			}	
			bw.write("c"+(assoc[i])+"");
			bw.newLine();
			bw.flush();
		}
		bw.close();
	}


	public static void saveSubKmeans(DipKM thea, String string) throws Exception {
		FileWriter fw = new FileWriter(string+".dat");
        BufferedWriter bw = new BufferedWriter(fw);
        ArrayList<double[]> data = thea.getDatapoints();
        int[] assoc = thea.association();
		int dim = thea.getDimension();
		for(int i=0;i<data.size();i++){
			bw.write((assoc[i])+";");
			for(int j=0;j<dim-1;j++){
				bw.write(data.get(i)[j]+"; ");
			}	
			bw.write(data.get(i)[dim-1]+"");
			bw.newLine();
			bw.flush();
		}
		bw.close();
	}


	public static void save(DipKM theo, int[] corr) throws IOException {
		BenUtil.save(theo,corr, "data");
	}

	public static void saveLabels(DipKM thear, String string) throws Exception {
		int[] label = thear.association();
		FileWriter fw = new FileWriter(string+".csv");
        BufferedWriter bw = new BufferedWriter(fw);
		for(int i=0;i<label.length;i++){
			
			bw.write((label[i])+"");
			bw.newLine();
			bw.flush();
		}
		bw.close();
		
	}

	public static void saveLabels(int[] lab, String string) throws IOException {
		FileWriter fw = new FileWriter(string+".csv");
        BufferedWriter bw = new BufferedWriter(fw);
		for(int i=0;i<lab.length;i++){
			bw.write((lab[i])+"");
			bw.newLine();
			bw.flush();
		}
		bw.close();
	}


	public static void addGauss(ArrayList<double[]> input,ArrayList<Integer> init, int clunum, int wieviel, double[] cent, double[] var){
		int dim = cent.length;	
		Random random = new Random();
		for(int i=0;i<wieviel;i++){
			double[] add = new double[dim];
			for(int j=0;j<dim;j++){
				add[j]=cent[j]+random.nextGaussian()*var[j];
			}
			input.add(add);
			init.add(clunum);
		}
	}

	public static void addDonut(ArrayList<double[]> input,ArrayList<Integer> init, int clunum, int wieviel,double[] cen, double in, double ext){
		int dim = cen.length;	
		Random random = new Random();
		for(int i=0;i<wieviel;i++){
			double[] add = new double[dim];
			
			for(int j=0;j<dim;j++){
				add[j]=cen[j]+(random.nextDouble()*2-1)*ext;
			}
			if(BenUtil.dist(add, cen)>in && BenUtil.dist(add, cen)<ext){
				input.add(add);
				init.add(clunum);
			}
		}
	}

	public static void addMoon(ArrayList<double[]> data, ArrayList<Integer> init, int clunum, int wieviel, double[] cen3,
			double[] cen4, double dist) {
		int dim = cen3.length;	
		Random random = new Random();
		for(int i=0;i<wieviel;i++){
			double[] add = new double[dim];
			
			for(int j=0;j<dim;j++){
				add[j]=cen3[j]+(random.nextDouble()*2-1)*dist;
			}
			if(BenUtil.dist(add, cen4)>(dist/1.5) && BenUtil.dist(add, cen3)<dist){
				data.add(add);
				init.add(clunum);
			}
		}
	}
	
	public static void printRealMatrix(RealMatrix a){
		double[][] tt = a.getData();
		for(int i=0;i<a.getColumnDimension();i++){
			for(int j=0;j<a.getRowDimension();j++){
				System.out.printf("%.3f ", tt[i][j]);
			}
			System.out.println();
		}
	}

	public static void printDip(DipKM thea) {
		double[] percent = new double[thea.getDimension()];
		double[] dip = new double[thea.getDimension()];
		DipKM.computeDipAndPercentValue(dip,percent,thea.getDatapoints());
		BenUtil.print(dip);
	}

	//Vector a wird auf b runterprojeziert
	public static double[] projeziereAuf(double[] a, double[] b) {
		double inPr = BenUtil.innereProduct(a,b);
		double[] neo = new double[b.length];
		
		for(int i=0;i<neo.length;i++){
			neo[i]=b[i]*inPr;
		}
		return neo;
	}

	private static double innereProduct(double[] a, double[] b) {
		double reto = 0;
		for(int i=0;i<a.length;i++){
			reto = reto + a[i]*b[i];
		}
		return reto;
	}

	public static double[] middle(double[] now, double[] centernow) {
		double[] middle = new double[now.length];
		for(int i=0;i<middle.length;i++){
			middle[i]=(now[i]+centernow[i])/2;
		}
		return middle;
	}
	
	public static double DipValue(double[] data){
		if(data.length<=5){
			return 0;
		}
		double[] at = jdistlib.disttest.DistributionTest.diptest(data);
		return at[0];
	}

	//Probability of a sample being unimodal
	public static double DipPercent(double[] data){
		if(data.length<=5){
			return 1;
		}
		double[] at = jdistlib.disttest.DistributionTest.diptest(data);
		return at[1];
	}
	
	//Probability of a sample being unimodal and the dipvalue
	public static double[] DipPercentAndValue(double[] data){
		double[] reto = new double[2];
		if(data.length<=5){
			reto[0] = 1;
			reto[1]	= 0.25;
			return reto;
		}
		double[] at = jdistlib.disttest.DistributionTest.diptest(data);
		reto[0] = at[1];
		reto[1] = at[0];
		return reto;
	}

	public static double[] ones(int size) {
		double[] reto = new double[size];
		for(int i=0;i<size;i++){
			reto[i]=1;
		}
		return reto;
	}

	public static void DBSCANResultsAAA() throws Exception{
		String[] t = {"7 vertebral column_3C","8 wifi_localization","10 BreastTissue","13 wine"};
		
		for(int j=0;j<t.length;j++){
			String dataSet =t[j];
			dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int k = BenUtil.getK(dataSet);
			System.out.println(dataSet);
			int[] label = thea.association();
			String loca21 = "AAA_DBSCAN";
			double tot=0;
			//13 winenormAAA_DBSCAN25-5-7
			for(int z=1;z<11;z++){
				String tested = dataSet+loca21+""+z+"-";
				//System.out.println(tested);
				if(tested.contains("DBSCAN")){
					double nm = 0;
					int[] a = {1,2,3,5,10,50};
					int[] b = {1,2,3,4,5,6,7};
					double nmi=0;
					for(int i=0;i<a.length;i++){
						for(int l=0;l<b.length;l++){
							String test = tested+""+a[i]+"-"+b[l]+"";
							//System.out.println(test);
							int[] laba = BenUtil.readLabelCSV(test+"");
							int off = BenUtil.min(laba);
							for(int kk=0;kk<laba.length;kk++){
								laba[kk]=laba[kk]-off+1;
							}
							nm=BenUtil.NMI(laba, label);
							nmi=Math.max(nm, nmi);
						}
					}
					//System.out.println(nmi);
					tot=tot+nmi;
				}
			}
			System.out.println(tot/10);
		}
	}

	public static void DBSCANResultsOther() throws Exception {
		String[] t = {"7 vertebral column_3C","8 wifi_localization","10 BreastTissue","13 wine"};
		for(int j=0;j<t.length;j++){
			String dataSet =t[j];
			dataSet = dataSet+"norm";
			String[] endung = {"","PCA", "ICA", "Dip", "zero"};
			for(int z=0;z<endung.length;z++){
				String dataS = dataSet+endung[z];
				
				DipKM thea = new DipKM(dataS,true);
				int k = BenUtil.getK(dataSet);
				System.out.println(dataS);
				int[] label = thea.association();
				String loca21 = "_DBSCAN";
				double tot=0;

				String tested = dataS+loca21;
					if(tested.contains("DBSCAN")){
						double nm = 0;
						int[] a = {1,2,3,5,10,50};
						int[] b = {1,2,3,4,5,6,7};
						double nmi=0;
						for(int i=0;i<a.length;i++){
							for(int l=0;l<b.length;l++){
								String test = tested+""+a[i]+"-"+b[l]+"";
								//System.out.println(test);
								int[] laba = BenUtil.readLabelCSV(test+"");
								int off = BenUtil.min(laba);
								for(int kk=0;kk<laba.length;kk++){
									laba[kk]=laba[kk]-off+1;
								}
								nm=BenUtil.NMI(laba, label);
								nmi=Math.max(nm, nmi);
							}
						}
						tot=tot+nmi;
					}
				System.out.println(tot);
			}
			System.out.println();
			}
			
	}

	public static void EMResults() throws Exception {
		String[] ttc = {"7 vertebral column_3C","8 wifi_localization","10 BreastTissue","13 wine"};
		for(int j=0;j<ttc.length;j++){
			String dataSet =ttc[j];
			dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int[] cor = thea.association();
			String[] endung = {"AAA","","PCA", "ICA", "Dip", "zero"};
			for(int z=0;z<6;z++){
				
				String dataS = dataSet+endung[z];
				System.out.println(dataS);
				double tot=0;
				for(int r=1;r<101;r++){
					String loca21 = "_EM";
					String test = dataS+loca21+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					//System.out.print(nm+"   ");
					tot=tot+nm;
				}
				
				System.out.printf("%.4f"+" ", (tot/(100)));
				System.out.println();
			}
		}	
	}
	

	public static void KMPPResults() throws Exception {
		String[] ttc = {"7 vertebral column_3C","8 wifi_localization","10 BreastTissue","13 wine"};
		for(int j=0;j<ttc.length;j++){
			String dataSet =ttc[j];
			dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int[] cor = thea.association();
			String[] endung = {"AAA","","PCA", "ICA", "Dip", "zero"};
			for(int z=0;z<6;z++){
				
				String dataS = dataSet+endung[z];
				System.out.println(dataS);
				double tot=0;
				for(int r=1;r<101;r++){
					String loca21 = "_kmeansplusplus";
					String test = dataS+loca21+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					//System.out.print(nm+"   ");
					tot=tot+nm;
				}
				
				System.out.printf("%.4f"+" ", (tot/(100)));
				System.out.println();
			}
		}	
	}

	public static void SingeLinkAAA() throws Exception {
		String[] ttc = {"7 vertebral column_3C","8 wifi_localization","10 BreastTissue","13 wine"};
		for(int j=0;j<ttc.length;j++){
			String dataSet =ttc[j];
			dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int[] cor = thea.association();
			String[] endung = {"AAA"};
			for(int z=0;z<1;z++){
				
				String dataS = dataSet+endung[z];
				System.out.println(dataS);
				double tot=0;
				for(int r=1;r<101;r++){
					String loca21 = "_singleLinkComplete";
					String test = dataS+loca21+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					//System.out.print(nm+"   ");
					tot=tot+nm;
				}
				
				System.out.println(tot/100);
			}
		}	
	}

	public static void SingeLink() throws Exception {
		String[] ttc = {"7 vertebral column_3C","8 wifi_localization","10 BreastTissue","13 wine"};
		for(int j=0;j<ttc.length;j++){
			String dataSet =ttc[j];
			dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int[] cor = thea.association();
			String[] endung = {"","PCA", "ICA", "Dip", "zero"};
			for(int z=0;z<5;z++){
				
				String dataS = dataSet+endung[z];
				System.out.println(dataS);
				double tot=0;
				//for(int r=1;r<101;r++){
					String loca21 = "_singleLinkComplete";
					String test = dataS+loca21;//+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					//System.out.print(nm+"   ");
					tot=tot+nm;
				//}
				
				System.out.println(tot);
			}
		}	
	}

	public static void SpectralResults() throws Exception {
		String[] ttc = {"7 vertebral column_3C","8 wifi_localization","10 BreastTissue","13 wine"};
		for(int j=0;j<ttc.length;j++){
			String dataSet =ttc[j];
			dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int[] cor = thea.association();
			String[] endung = {"AAA","","PCA", "ICA", "Dip", "zero"};
			for(int z=0;z<6;z++){
				
				String dataS = dataSet+endung[z];
				System.out.println(dataS);
				double tot=0;
				for(int r=1;r<11;r++){
					String loca21 = "_spec";
					String test = dataS+loca21+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					//System.out.print(nm+"   ");
					tot=tot+nm;
				}
				System.out.println(tot/10);
				
			}System.out.println();
		}	
	}
	
	public static void KMPPResultsTotal() throws Exception {
		String[] ttc = {"4 iris","7 vertebral column_3C","7 seeds", "8 wifi_localization", "9 breast-cancer-wisconsin","10 BreastTissue","13 wine"};
		String[] endung = {"AAA","","PCA", "ICA", "Dip", "zero"};
		
		for(int z=0;z<6;z++){
			if(endung[z].length()>2){
				System.out.println(endung[z]);
			} else {
				System.out.println("norm");
			}
			
			double tot=0;
			for(int j=0;j<ttc.length;j++){
				String dataSet =ttc[j];
				dataSet = dataSet+"norm";
				DipKM thea = new DipKM(dataSet,true);
				int[] cor = thea.association();
				
				String dataS = dataSet+endung[z];
				
				
				for(int r=1;r<101;r++){
					String loca21 = "_kmeansplusplus";
					String test = dataS+loca21+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					tot=tot+nm;
				}
			}

			System.out.println(tot/700);
		}
	}



	public static void EMResultsTotal() throws Exception {
		String[] ttc = {"4 iris","7 vertebral column_3C","7 seeds", "8 wifi_localization", "9 breast-cancer-wisconsin","10 BreastTissue","13 wine"};
		String[] endung = {"AAA","","PCA", "ICA", "Dip", "zero"};
		
		for(int z=0;z<6;z++){
			if(endung[z].length()>2){
				System.out.println(endung[z]);
			} else {
				System.out.println("norm");
			}
			
			double tot=0;
			for(int j=0;j<ttc.length;j++){
				String dataSet =ttc[j];
				dataSet = dataSet+"norm";
				DipKM thea = new DipKM(dataSet,true);
				int[] cor = thea.association();
				
				String dataS = dataSet+endung[z];
				
				
				for(int r=1;r<101;r++){
					String loca21 = "_EM";
					String test = dataS+loca21+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					tot=tot+nm;
				}
			}

			System.out.println(tot/700);
		}
	}

	public static void SpectralResultsTotal() throws Exception {
		String[] ttc = {"4 iris","7 vertebral column_3C","7 seeds", "8 wifi_localization", "9 breast-cancer-wisconsin","10 BreastTissue","13 wine"};
		String[] endung = {"AAA","","PCA", "ICA", "Dip", "zero"};
		
		for(int z=0;z<6;z++){
			if(endung[z].length()>2){
				System.out.println(endung[z]);
			} else {
				System.out.println("norm");
			}
			
			double tot=0;
			for(int j=0;j<ttc.length;j++){
				String dataSet =ttc[j];
				dataSet = dataSet+"norm";
				DipKM thea = new DipKM(dataSet,true);
				int[] cor = thea.association();
				
				String dataS = dataSet+endung[z];
				
				
				for(int r=1;r<11;r++){
					String loca21 = "_spec";
					String test = dataS+loca21+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					tot=tot+nm;
				}
			}

			System.out.println(tot/70);
		}
	}

	public static void SingeLinkAAATotal() throws Exception {
		String[] ttc = {"4 iris","7 vertebral column_3C","7 seeds", "8 wifi_localization", "9 breast-cancer-wisconsin","10 BreastTissue","13 wine"};
		double tot=0;
		System.out.println("PCE");
		for(int j=0;j<ttc.length;j++){
			String dataSet =ttc[j];
			dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int[] cor = thea.association();
			String[] endung = {"AAA"};
			for(int z=0;z<1;z++){
				
				String dataS = dataSet+endung[z];
				//System.out.println(dataS);
				
				for(int r=1;r<101;r++){
					String loca21 = "_singleLinkComplete";
					String test = dataS+loca21+""+r;
					int[] laba = BenUtil.readLabelCSV(test+"");
					double nm = BenUtil.NMI(cor, laba);
					//System.out.print(nm+"   ");
					tot=tot+nm;
				}
				
				
			}
		}	
		System.out.println(tot/700);
	}

	public static void SingeLinkTotal() throws Exception {
		String[] ttc = {"4 iris","7 vertebral column_3C","7 seeds", "8 wifi_localization", "9 breast-cancer-wisconsin","10 BreastTissue","13 wine"};
		String[] endung = {"","PCA", "ICA", "Dip", "zero"};
		
		for(int z=0;z<5;z++){
			if(endung[z].length()>2){
				System.out.println(endung[z]);
			} else {
				System.out.println("norm");
			}
			double tot=0;
			for(int j=0;j<ttc.length;j++){
				String dataSet =ttc[j];
				dataSet = dataSet+"norm";
				DipKM thea = new DipKM(dataSet,true);
				int[] cor = thea.association();
					String dataS = dataSet+endung[z];
						String loca21 = "_singleLinkComplete";
						String test = dataS+loca21;//+""+r;
						int[] laba = BenUtil.readLabelCSV(test+"");
						double nm = BenUtil.NMI(cor, laba);
						//System.out.print(nm+"   ");
						tot=tot+nm;
				
			}	
			System.out.println(tot/7);
		}
	}

	public static void DBSCANResultsAAATotal() throws Exception {
		String[] t = {"4 iris","7 vertebral column_3C","7 seeds", "8 wifi_localization", "9 breast-cancer-wisconsin","10 BreastTissue","13 wine"};
		System.out.println("PCE");
		double all=0;
		for(int j=0;j<t.length;j++){
			String dataSet =t[j];
			dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int k = BenUtil.getK(dataSet);
			
			int[] label = thea.association();
			String loca21 = "AAA_DBSCAN";
			double tot=0;
			//13 winenormAAA_DBSCAN25-5-7
			for(int z=1;z<11;z++){
				String tested = dataSet+loca21+""+z+"-";
				//System.out.println(tested);
				if(tested.contains("DBSCAN")){
					double nm = 0;
					int[] a = {1,2,3,5,10,50};
					int[] b = {1,2,3,4,5,6,7};
					double nmi=0;
					for(int i=0;i<a.length;i++){
						for(int l=0;l<b.length;l++){
							String test = tested+""+a[i]+"-"+b[l]+"";
							//System.out.println(test);
							int[] laba = BenUtil.readLabelCSV(test+"");
							int off = BenUtil.min(laba);
							for(int kk=0;kk<laba.length;kk++){
								laba[kk]=laba[kk]-off+1;
							}
							nm=BenUtil.NMI(laba, label);
							nmi=Math.max(nm, nmi);
						}
					}
					//System.out.println(nmi);
					tot=tot+nmi;
				}
			}
			all = all+tot;
		}
		System.out.println(all/70);
	}
	
	public static void DBSCANResultsOtherTotal() throws Exception {
		String[] t = {"4 iris","7 vertebral column_3C","7 seeds", "8 wifi_localization", "9 breast-cancer-wisconsin","10 BreastTissue","13 wine"};
		String[] endung = {"","PCA", "ICA", "Dip", "zero"};
		
		for(int z=0;z<endung.length;z++){
			if(endung[z].length()>2){
				System.out.println(endung[z]);
			} else {
				System.out.println("norm");
			}
			double all=0;
			for(int j=0;j<t.length;j++){
				String dataSet =t[j];
				dataSet = dataSet+"norm";
				String dataS = dataSet+endung[z];
				
				DipKM thea = new DipKM(dataS,true);
				int k = BenUtil.getK(dataSet);
				//System.out.println(dataS);
				int[] label = thea.association();
				String loca21 = "_DBSCAN";
				double tot=0;

				String tested = dataS+loca21;
					if(tested.contains("DBSCAN")){
						double nm = 0;
						int[] a = {1,2,3,5,10,50};
						int[] b = {1,2,3,4,5,6,7};
						double nmi=0;
						for(int i=0;i<a.length;i++){
							for(int l=0;l<b.length;l++){
								String test = tested+""+a[i]+"-"+b[l]+"";
								//System.out.println(test);
								int[] laba = BenUtil.readLabelCSV(test+"");
								int off = BenUtil.min(laba);
								for(int kk=0;kk<laba.length;kk++){
									laba[kk]=laba[kk]-off+1;
								}
								nm=BenUtil.NMI(laba, label);
								nmi=Math.max(nm, nmi);
							}
						}
						tot=tot+nmi;
					}
				all=all+tot;	
				}
				System.out.println(all/7);
			}
		
			
	}

	public static void extractIDEC(String t) throws IOException {
		ArrayList<Integer> label = new ArrayList<Integer>(); 
		FileReader fr = new FileReader("./label/"+t+"-idec"+".csv");
	    @SuppressWarnings("resource")
		BufferedReader br = new BufferedReader(fr);
	    String input = br.readLine();
	    
	    String[] tokens = input.split(",");
		int dim = tokens.length;
		ArrayList<int[]> da = new ArrayList<int[]>();
		
	    while(input!=null){
		    input=input.replace(" ", "");
		    input=input.replace("	", "");
		    input=input.replace("\"", "");
			tokens = input.split(",");
			int[] add = new int[dim];
			
	    	for(int i=0;i<dim;i++){
	    		add[i]=Integer.parseInt(tokens[i]);
	    	}
	    	da.add(add);
	    	input=br.readLine();
	    	BenUtil.print(add);
	    }
	    
	    
	    
	    for(int i=1;i<11;i++){
	    	int[] la = new int[da.size()];
	    	for(int k=0;k<da.size();k++){
	    		la[k]=(int) da.get(k)[i];
	    	}
	    	BenUtil.saveLabels(la, t+"_idec"+i);
	    }
	}

	public static void extractDEC(String t) throws IOException {
		ArrayList<Integer> label = new ArrayList<Integer>(); 
		FileReader fr = new FileReader("./label/"+t+"-dec"+".csv");
	    @SuppressWarnings("resource")
		BufferedReader br = new BufferedReader(fr);
	    String input = br.readLine();
	    
	    String[] tokens = input.split(",");
		int dim = tokens.length;
		ArrayList<int[]> da = new ArrayList<int[]>();
		
	    while(input!=null){
		    input=input.replace(" ", "");
		    input=input.replace("	", "");
		    input=input.replace("\"", "");
			tokens = input.split(",");
			int[] add = new int[dim];
			
	    	for(int i=0;i<dim;i++){
	    		add[i]=Integer.parseInt(tokens[i]);
	    	}
	    	da.add(add);
	    	input=br.readLine();
	    	BenUtil.print(add);
	    }
	    
	    
	    
	    for(int i=1;i<11;i++){
	    	int[] la = new int[da.size()];
	    	for(int k=0;k<da.size();k++){
	    		la[k]=(int) da.get(k)[i];
	    	}
	    	BenUtil.saveLabels(la, t+"_dec"+i);
	    }
	}





	
}
