package main;


import java.io.IOException;
//import java.text.*;
import java.util.*;
import java.util.stream.Collectors;

import org.apache.commons.math3.linear.EigenDecomposition;
import org.apache.commons.math3.linear.MatrixUtils;
import org.apache.commons.math3.linear.RealMatrix;
import org.apache.commons.math3.stat.correlation.Covariance;

import kmeans.KMmain;




public class DipKM {

	private int k;
	private int dim;
	private double[][] borders;
	private ArrayList<double[]> datapoints;
	private ArrayList<double[]> centres;
	private ArrayList<Cluster> cluster;

	
	public DipKM(ArrayList<double[]> data, int[] init) throws Exception {
		this.setDatapoints(new ArrayList<double[]>());
		this.setCluster();
		int min = BenUtil.min(init);
		for(int i=0;i<data.size();i++){
			this.addClusterIndex(data.get(i), (init[i]-min));
		}
		this.setDimension(data.get(0).length);
		this.setBorders();
		this.setCentres(new ArrayList<double[]>());
	}
	
	public DipKM(ArrayList<double[]> data, ArrayList<Integer> init) {
		this.setDatapoints(new ArrayList<double[]>());
		this.setCluster();
		int min = BenUtil.min(init);
		for(int i=0;i<data.size();i++){
			this.addClusterIndex(data.get(i), (init.get(i)-min));
		}
		this.setDimension(data.get(0).length);
		this.setBorders();
		this.setCentres(new ArrayList<double[]>());
	}

	
	
	public DipKM(String s,Boolean t) throws Exception {
		if(t==true){
			this.setDatapoints(new ArrayList<double[]>());
			this.setCluster();
			BenUtil.read(this, s);
			this.setBorders();
			this.setCentres(new ArrayList<double[]>());
		} else {
			this.setDatapoints(new ArrayList<double[]>());
			this.setCluster();
			BenUtil.read2(this, s);
			this.setBorders();
			this.setCentres(new ArrayList<double[]>());
		}
	}
	
	public DipKM(String s) throws Exception {
		this.setDatapoints(new ArrayList<double[]>());
		this.setCluster();
		BenUtil.read(this, s);
		this.setBorders();
		this.setCentres(new ArrayList<double[]>());
	}
	
	
	//this is where PCE actually happens. Sorry for the spaghetti code
	public static int[] tempMethod4(DipKM thea, int kk, int[] corr, Boolean plot, Boolean comment,double divi, Boolean randomize, Boolean halved,Boolean exp,Boolean normalize) throws Exception{
		if(normalize){
			thea.normalize();
		}
		
		ArrayList<Double> nmi = new ArrayList<Double>();
		int k = kk;
		
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(k, -1, null);
		int[] la = te.getLabel();
		
		/*int[] la = null;
		double SSE=Double.MAX_VALUE;
		for(int i=0;i<1;i++){
			KMmain te = new KMmain(thea.getDatapoints());
			te.clustering(k, -1, null);
			int[] lab = te.getLabel();
			double[][] cent = te.getCentroids();
			
			double SSEnew = BenUtil.computeSSE(thea, lab, cent);
			if(SSEnew<SSE){
				la=lab;
				SSE = SSEnew;
			}
		}*/
		
		int[] orig = la.clone();
		int[] memory = la.clone();
		thea.emptyCluster();
		thea.fillCluster(la);
		thea.removeEmptyCluster();
		double[][] centerKmeans = new double[k][thea.getDimension()];
		ArrayList<double[]> datacopy = new ArrayList<double[]>();
		for(int i=0;i<thea.getDatapoints().size();i++){
			datacopy.add(thea.getDatapoints().get(i).clone());
		}
		
		int counter=0;
		Boolean cont = true;
		while(cont){
			//pro cluster die richtungen mit pca/dip berechnen
			ArrayList<double[][]> directions = new ArrayList<double[][]>();
			ArrayList<double[][]> projections = new ArrayList<double[][]>();

			ArrayList<double[]> strength = new ArrayList<double[]>();
			ArrayList<double[]> strengthunscaled = new ArrayList<double[]>();
			ArrayList<double[]> dippercent = new ArrayList<double[]>();
			ArrayList<double[]> dipvalue = new ArrayList<double[]>();
		
			for(int i=0;i<thea.getCluster().size();i++){
				ArrayList<double[]> clusterData = thea.getClusterData(i);
				
				double[][] projection = new double[thea.getDimension()][thea.getDimension()];
				double clustervariance = 0;
				double[] str = new double[thea.getDimension()];
				double[] strunscaled = new double[thea.getDimension()];
				double[] pers = new double[thea.getDimension()];
				double[] dips = new double[thea.getDimension()];
				
				Cluster cl = thea.getCluster().get(i);
				
				double[][] dir = DipKM.computeDirection(cl, thea);
				directions.add(dir);
				
				//compute the projections of the cluster into each direction and its variance, as well as the overall variance
				for(int j=0;j<str.length;j++){
					double[] proj = BenUtil.getProjection(clusterData, directions.get(i)[j]);
					projection[j] = proj;
					double var = BenUtil.getVariance(proj);
					str[j] = Math.sqrt(var);
					
					
					clustervariance = clustervariance + var;
					double[] perdip = BenUtil.DipPercentAndValue(proj);
					double per = perdip[0];
					double dip = perdip[1];
					pers[j]=per;
					dips[j]=dip;

					//per is probability of being uni-modal; 1-prob of being multimodal
					str[j] = str[j]*(1+per);
					
					strunscaled[j]=str[j];
				}
				projections.add(projection);
				strength.add(str);
				strengthunscaled.add(strunscaled);
				dippercent.add(pers);
				dipvalue.add(dips);
			}
			
			//strength normalisieren
			BenUtil.divideMean(strength);
						thea.updateCenter();
			ArrayList<double[]> center = thea.getCentres();
						//plot ma mal
			if(plot){
				Paint.plotClusterPCA(thea, directions, strength);
				thea.setBorders(thea.findBorders());
				Paint.plot(thea);
				Thread.sleep(200);
			}
			
			//fr jeden datenpunkt die richtungen der einzelnen cluster relativ zur gewichtung, dh die distanz zum jeweiligen centrum berechnen
			ArrayList<double[]> changes = new ArrayList<double[]>();
			//Betrachten alle datenpunkte
			for(int i=0;i<thea.getDatapoints().size();i++){
				double[] datapoint = thea.getDatapoints().get(i);
				double[] now = new double[datapoint.length];
				
				//hier werden alle cluster durchgegangen fr die datenpunkte
				for(int j=0;j<directions.size();j++){
					
					double[] str = strength.get(j);
					double[] strunscaled = strengthunscaled.get(j);
					double[][] direct = directions.get(j);
					double[] centernow = center.get(j); 
					//double[] dips = dipvalue.get(j);
						
					double[] relvect = BenUtil.substract(datapoint, centernow);
					//alle richtungen auf den datenpunkt wirken sich aus
					for(int l=0;l<direct.length;l++){
												
						double[] direction = direct[l];
						
						//geht mit der formel nur weil direction schon normiert ist.
						double[] pro = BenUtil.projeziereAuf(relvect, direction);
						
						//wie weit ist der datenpunkt von dem center bzgl des einflusses entfernt 
						double ver = BenUtil.norm(pro);
						
						double mo = 0;
						if(exp){
							mo = (ver)/(Math.exp(ver/strunscaled[l]/divi));
						} else {
							mo = strunscaled[l]*divi*Math.log((ver/strunscaled[l]/divi)+1);
						}

						pro = BenUtil.normalize(pro);
						
						//berechnen hier quasi das vorzeichen der bewegung. bei varianz kleiner 1 (relativ zu den anderen ausbreitungen), wird das ganze negativ und der cluster wird in der richtung zusammengezogen. Grer 1 wird auseinandergezogen				
						double stre = 1/str[l]-1;
						
						
						double verschiebum = stre*mo;
						if(halved){
							verschiebum = verschiebum/2;
						}
						//verlangsame den gesamten prozess
									//sammeln die gesamten verschiebungen, die auf den datenpunkt datapoint ausgefhrt werden sollen
						now = BenUtil.add(now, BenUtil.mult(pro, verschiebum));
						//now = BenUtil.add(now, pro);
					}
				}
				//BenUtil.print(now);
				changes.add(now);
			}

			//hier werden die gesamten nderungen, die gesammelt wurden tatschlich ausgefhrt. die gesamt-nderungs vektor kommt zum datenpunkt hinzu
			for(int i=0;i<thea.getDatapoints().size();i++){
				double[] no = thea.getDatapoints().get(i);
				no = BenUtil.add(no,changes.get(i));
			}
			
			if(plot){
				//Paint.plotClusterPCA(thea, directions, strength);
				//Paint.plot(thea);
				Thread.sleep(200);
			}

			thea.updateCenter();
			for(int cen=0;cen<centerKmeans.length;cen++){
				centerKmeans[cen]=thea.getCentres().get(cen);
			}
			
			la = DipKM.kMeansResult(thea, centerKmeans);
			double ueber = BenUtil.NMI(memory, la);
			if(randomize){
				la = DipKM.kMeansResult(thea, k);
			}
			
			if(ueber>0.9999999999 || Double.isNaN(ueber)){
				cont=false;
			} else {
				cont=true;
			}
			if(counter>100){
				cont=false;
			}
			counter++;
			//System.out.println(counter);
			memory = la.clone();
			thea.emptyCluster();
			thea.fillCluster(la);
			thea.removeEmptyCluster();
		}
		if(comment){
			System.out.print("Number of rounds: ");
			System.out.println(counter);
		}
		return la;
	}
	
	//exactly like before, only one can start with predefined starting centers.
	public static int[] tempMethod4(DipKM thea, int kk, int[] corr, Boolean plot, Boolean comment,double divi, Boolean randomize, Boolean halved,Boolean exp,Boolean normalize, double[][] startcenter) throws Exception{
		if(normalize){
			thea.normalize();
		}
		
		ArrayList<Double> nmi = new ArrayList<Double>();
		int k = kk;
		
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(k, -1, startcenter);
		int[] la = te.getLabel();
		
		/*int[] la = null;
		double SSE=Double.MAX_VALUE;
		for(int i=0;i<100;i++){
			KMmain te = new KMmain(thea.getDatapoints());
			te.clustering(k, -1, null);
			int[] lab = te.getLabel();
			double[][] cent = te.getCentroids();
			
			double SSEnew = BenUtil.computeSSE(thea, lab, cent);
			if(SSEnew<SSE){
				la=lab;
				SSE = SSEnew;
			}
		}*/
		
		int[] orig = la.clone();
		int[] memory = la.clone();
		thea.emptyCluster();
		thea.fillCluster(la);
		thea.removeEmptyCluster();
		double[][] centerKmeans = new double[k][thea.getDimension()];
		ArrayList<double[]> datacopy = new ArrayList<double[]>();
		for(int i=0;i<thea.getDatapoints().size();i++){
			datacopy.add(thea.getDatapoints().get(i).clone());
		}
		
		int counter=0;
		Boolean cont = true;
		while(cont){
			//pro cluster die richtungen mit pca/dip berechnen
			ArrayList<double[][]> directions = new ArrayList<double[][]>();
			ArrayList<double[][]> projections = new ArrayList<double[][]>();

			ArrayList<double[]> strength = new ArrayList<double[]>();
			ArrayList<double[]> strengthunscaled = new ArrayList<double[]>();
			ArrayList<double[]> dippercent = new ArrayList<double[]>();
			ArrayList<double[]> dipvalue = new ArrayList<double[]>();
		
			for(int i=0;i<thea.getCluster().size();i++){
				ArrayList<double[]> clusterData = thea.getClusterData(i);
				
				double[][] projection = new double[thea.getDimension()][thea.getDimension()];
				double clustervariance = 0;
				double[] str = new double[thea.getDimension()];
				double[] strunscaled = new double[thea.getDimension()];
				double[] pers = new double[thea.getDimension()];
				double[] dips = new double[thea.getDimension()];
				
				Cluster cl = thea.getCluster().get(i);
				
				double[][] dir = DipKM.computeDirection(cl, thea);
				directions.add(dir);
				
				//compute the projections of the cluster into each direction and its variance, as well as the overall variance
				for(int j=0;j<str.length;j++){
					double[] proj = BenUtil.getProjection(clusterData, directions.get(i)[j]);
					projection[j] = proj;
					double var = BenUtil.getVariance(proj);
					str[j] = Math.sqrt(var);
					
					
					clustervariance = clustervariance + var;
					double[] perdip = BenUtil.DipPercentAndValue(proj);
					double per = perdip[0];
					double dip = perdip[1];
					pers[j]=per;
					dips[j]=dip;

					//per is probability of being uni-modal; 1-prob of being multimodal
					str[j] = str[j]*(1+per);
					
					strunscaled[j]=str[j];
				}
				projections.add(projection);
				strength.add(str);
				strengthunscaled.add(strunscaled);
				dippercent.add(pers);
				dipvalue.add(dips);
			}
			
			//strength normalisieren
			BenUtil.divideMean(strength);
						thea.updateCenter();
			ArrayList<double[]> center = thea.getCentres();
						//plot ma mal
			if(plot){
				Paint.plotClusterPCA(thea, directions, strength);
				Thread.sleep(200);
				//thea.setBorders(thea.findBorders());
				//Paint.plot(thea);
				//Thread.sleep(200);
			}
			
			//fr jeden datenpunkt die richtungen der einzelnen cluster relativ zur gewichtung, dh die distanz zum jeweiligen centrum berechnen
			ArrayList<double[]> changes = new ArrayList<double[]>();
			//Betrachten alle datenpunkte
			for(int i=0;i<thea.getDatapoints().size();i++){
				double[] datapoint = thea.getDatapoints().get(i);
				double[] now = new double[datapoint.length];
				
				//hier werden alle cluster durchgegangen fr die datenpunkte
				for(int j=0;j<directions.size();j++){
					
					double[] str = strength.get(j);
					double[] strunscaled = strengthunscaled.get(j);
					double[][] direct = directions.get(j);
					double[] centernow = center.get(j); 
					//double[] dips = dipvalue.get(j);
						
					double[] relvect = BenUtil.substract(datapoint, centernow);
					//alle richtungen auf den datenpunkt wirken sich aus
					for(int l=0;l<direct.length;l++){
												
						double[] direction = direct[l];
						
						//geht mit der formel nur weil direction schon normiert ist.
						double[] pro = BenUtil.projeziereAuf(relvect, direction);
						
						//wie weit ist der datenpunkt von dem center bzgl des einflusses entfernt 
						double ver = BenUtil.norm(pro);
						
						double mo = 0;
						if(exp){
							mo = (ver)/(Math.exp(ver/strunscaled[l]/divi));
						} else {
							mo = strunscaled[l]*divi*Math.log((ver/strunscaled[l]/divi)+1);
						}

						pro = BenUtil.normalize(pro);
						
						//berechnen hier quasi das vorzeichen der bewegung. bei varianz kleiner 1 (relativ zu den anderen ausbreitungen), wird das ganze negativ und der cluster wird in der richtung zusammengezogen. Grer 1 wird auseinandergezogen				
						double stre = 1/str[l]-1;
						
						
						double verschiebum = stre*mo;
						if(halved){
							verschiebum = verschiebum/2;
						}
						//verlangsame den gesamten prozess
									//sammeln die gesamten verschiebungen, die auf den datenpunkt datapoint ausgefhrt werden sollen
						now = BenUtil.add(now, BenUtil.mult(pro, verschiebum));
						//now = BenUtil.add(now, pro);
					}
				}
				//BenUtil.print(now);
				changes.add(now);
			}

			//hier werden die gesamten nderungen, die gesammelt wurden tatschlich ausgefhrt. die gesamt-nderungs vektor kommt zum datenpunkt hinzu
			for(int i=0;i<thea.getDatapoints().size();i++){
				double[] no = thea.getDatapoints().get(i);
				no = BenUtil.add(no,changes.get(i));
			}
			
			/*if(plot){
				//Paint.plotClusterPCA(thea, directions, strength);
				//Thread.sleep(200);
				thea.setBorders(thea.findBorders());
				Paint.plot(thea);
				Thread.sleep(200);
			}*/

			thea.updateCenter();
			for(int cen=0;cen<centerKmeans.length;cen++){
				centerKmeans[cen]=thea.getCentres().get(cen);
			}
			
			la = DipKM.kMeansResult(thea, centerKmeans);
			double ueber = BenUtil.NMI(memory, la);
			if(randomize){
				la = DipKM.kMeansResult(thea, k);
			}
			
			if(ueber>0.9999999999 || Double.isNaN(ueber)){
				cont=false;
			} else {
				cont=true;
			}
			if(counter>100){
				cont=false;
			}
			counter++;
			memory = la.clone();
			thea.emptyCluster();
			thea.fillCluster(la);
			thea.removeEmptyCluster();
		}
		if(comment){
			System.out.print("Number of rounds: ");
			System.out.println(counter);
		}
		return la;
	}
	
	//exactly like before, only one can start with predefined initialisation.
		public static int[] tempMethod4(DipKM thea, int kk, int[] corr, Boolean plot, Boolean comment,double divi, Boolean randomize, Boolean halved,Boolean exp,Boolean normalize, int[] start) throws Exception{
			if(normalize){
				thea.normalize();
			}
			
			ArrayList<Double> nmi = new ArrayList<Double>();
			int k = kk;
			
			int[] la = start;
			
			/*int[] la = null;
			double SSE=Double.MAX_VALUE;
			for(int i=0;i<100;i++){
				KMmain te = new KMmain(thea.getDatapoints());
				te.clustering(k, -1, null);
				int[] lab = te.getLabel();
				double[][] cent = te.getCentroids();
				
				double SSEnew = BenUtil.computeSSE(thea, lab, cent);
				if(SSEnew<SSE){
					la=lab;
					SSE = SSEnew;
				}
			}*/
			
			int[] orig = la.clone();
			int[] memory = la.clone();
			thea.emptyCluster();
			thea.fillCluster(la);
			thea.removeEmptyCluster();
			double[][] centerKmeans = new double[k][thea.getDimension()];
			ArrayList<double[]> datacopy = new ArrayList<double[]>();
			for(int i=0;i<thea.getDatapoints().size();i++){
				datacopy.add(thea.getDatapoints().get(i).clone());
			}
			
			int counter=0;
			Boolean cont = true;
			while(cont){
				//pro cluster die richtungen mit pca/dip berechnen
				ArrayList<double[][]> directions = new ArrayList<double[][]>();
				ArrayList<double[][]> projections = new ArrayList<double[][]>();

				ArrayList<double[]> strength = new ArrayList<double[]>();
				ArrayList<double[]> strengthunscaled = new ArrayList<double[]>();
				ArrayList<double[]> dippercent = new ArrayList<double[]>();
				ArrayList<double[]> dipvalue = new ArrayList<double[]>();
			
				for(int i=0;i<thea.getCluster().size();i++){
					ArrayList<double[]> clusterData = thea.getClusterData(i);
					
					double[][] projection = new double[thea.getDimension()][thea.getDimension()];
					double clustervariance = 0;
					double[] str = new double[thea.getDimension()];
					double[] strunscaled = new double[thea.getDimension()];
					double[] pers = new double[thea.getDimension()];
					double[] dips = new double[thea.getDimension()];
					
					Cluster cl = thea.getCluster().get(i);
					
					double[][] dir = DipKM.computeDirection(cl, thea);
					directions.add(dir);
					
					//compute the projections of the cluster into each direction and its variance, as well as the overall variance
					for(int j=0;j<str.length;j++){
						double[] proj = BenUtil.getProjection(clusterData, directions.get(i)[j]);
						projection[j] = proj;
						double var = BenUtil.getVariance(proj);
						str[j] = Math.sqrt(var);
						
						
						clustervariance = clustervariance + var;
						double[] perdip = BenUtil.DipPercentAndValue(proj);
						double per = perdip[0];
						double dip = perdip[1];
						pers[j]=per;
						dips[j]=dip;

						//per is probability of being uni-modal; 1-prob of being multimodal
						str[j] = str[j]*(1+per);
						
						strunscaled[j]=str[j];
					}
					projections.add(projection);
					strength.add(str);
					strengthunscaled.add(strunscaled);
					dippercent.add(pers);
					dipvalue.add(dips);
				}
				
				//strength normalisieren
				BenUtil.divideMean(strength);
							thea.updateCenter();
				ArrayList<double[]> center = thea.getCentres();
							//plot ma mal
				if(plot){
					Paint.plotClusterPCA(thea, directions, strength);
					Thread.sleep(200);
					//thea.setBorders(thea.findBorders());
					//Paint.plot(thea);
					//Thread.sleep(200);
				}
				
				//fr jeden datenpunkt die richtungen der einzelnen cluster relativ zur gewichtung, dh die distanz zum jeweiligen centrum berechnen
				ArrayList<double[]> changes = new ArrayList<double[]>();
				//Betrachten alle datenpunkte
				for(int i=0;i<thea.getDatapoints().size();i++){
					double[] datapoint = thea.getDatapoints().get(i);
					double[] now = new double[datapoint.length];
					
					//hier werden alle cluster durchgegangen fr die datenpunkte
					for(int j=0;j<directions.size();j++){
						
						double[] str = strength.get(j);
						double[] strunscaled = strengthunscaled.get(j);
						double[][] direct = directions.get(j);
						double[] centernow = center.get(j); 
						//double[] dips = dipvalue.get(j);
							
						double[] relvect = BenUtil.substract(datapoint, centernow);
						//alle richtungen auf den datenpunkt wirken sich aus
						for(int l=0;l<direct.length;l++){
													
							double[] direction = direct[l];
							
							//geht mit der formel nur weil direction schon normiert ist.
							double[] pro = BenUtil.projeziereAuf(relvect, direction);
							
							//wie weit ist der datenpunkt von dem center bzgl des einflusses entfernt 
							double ver = BenUtil.norm(pro);
							
							double mo = 0;
							if(exp){
								mo = (ver)/(Math.exp(ver/strunscaled[l]/divi));
							} else {
								mo = strunscaled[l]*divi*Math.log((ver/strunscaled[l]/divi)+1);
							}

							pro = BenUtil.normalize(pro);
							
							//berechnen hier quasi das vorzeichen der bewegung. bei varianz kleiner 1 (relativ zu den anderen ausbreitungen), wird das ganze negativ und der cluster wird in der richtung zusammengezogen. Grer 1 wird auseinandergezogen				
							double stre = 1/str[l]-1;
							
							
							double verschiebum = stre*mo;
							if(halved){
								verschiebum = verschiebum/2;
							}
							//verlangsame den gesamten prozess
										//sammeln die gesamten verschiebungen, die auf den datenpunkt datapoint ausgefhrt werden sollen
							now = BenUtil.add(now, BenUtil.mult(pro, verschiebum));
							//now = BenUtil.add(now, pro);
						}
					}
					//BenUtil.print(now);
					changes.add(now);
				}

				//hier werden die gesamten nderungen, die gesammelt wurden tatschlich ausgefhrt. die gesamt-nderungs vektor kommt zum datenpunkt hinzu
				for(int i=0;i<thea.getDatapoints().size();i++){
					double[] no = thea.getDatapoints().get(i);
					no = BenUtil.add(no,changes.get(i));
				}
				
				/*if(plot){
					//Paint.plotClusterPCA(thea, directions, strength);
					//Thread.sleep(200);
					thea.setBorders(thea.findBorders());
					Paint.plot(thea);
					Thread.sleep(200);
				}*/

				thea.updateCenter();
				for(int cen=0;cen<centerKmeans.length;cen++){
					centerKmeans[cen]=thea.getCentres().get(cen);
				}
				
				la = DipKM.kMeansResult(thea, centerKmeans);
				double ueber = BenUtil.NMI(memory, la);
				if(randomize){
					la = DipKM.kMeansResult(thea, k);
				}
				
				if(ueber>0.9999999999 || Double.isNaN(ueber)){
					cont=false;
				} else {
					cont=true;
				}
				if(counter>100){
					cont=false;
				}
				counter++;
				memory = la.clone();
				thea.emptyCluster();
				thea.fillCluster(la);
				thea.removeEmptyCluster();
			}
			if(comment){
				System.out.print("Number of rounds: ");
				System.out.println(counter);
			}
			return la;
		}
	
	public static double oneRound(DipKM thea, int kk, int[] corr, int[] la, double divi, Boolean randomize, Boolean halved, Boolean exp){
		thea.emptyCluster();
		thea.fillCluster(la);
		thea.removeEmptyCluster();

			//pro cluster die richtungen mit pca/dip berechnen
			ArrayList<double[][]> directions = new ArrayList<double[][]>();
			ArrayList<double[][]> projections = new ArrayList<double[][]>();

			ArrayList<double[]> strength = new ArrayList<double[]>();
			ArrayList<double[]> strengthunscaled = new ArrayList<double[]>();
			ArrayList<double[]> dippercent = new ArrayList<double[]>();
			ArrayList<double[]> dipvalue = new ArrayList<double[]>();
			double div = 0;
			int count=0;
			
			for(int i=0;i<thea.getCluster().size();i++){
				ArrayList<double[]> clusterData = thea.getClusterData(i);
				
				double[][] projection = new double[thea.getDimension()][thea.getDimension()];
				double clustervariance = 0;
				double[] str = new double[thea.getDimension()];
				double[] strunscaled = new double[thea.getDimension()];
				double[] pers = new double[thea.getDimension()];
				double[] dips = new double[thea.getDimension()];
				
				Cluster cl = thea.getCluster().get(i);
				
				double[][] dir = DipKM.computeDirection(cl, thea);
				directions.add(dir);
				
				//compute the projections of the cluster into each direction and its variance, as well as the overall variance
				for(int j=0;j<str.length;j++){
					double[] proj = BenUtil.getProjection(clusterData, directions.get(i)[j]);
					projection[j] = proj;
					double var = BenUtil.getVariance(proj);
					str[j] = Math.sqrt(var);
					
					
					clustervariance = clustervariance + var;
					double[] perdip = BenUtil.DipPercentAndValue(proj);
					double per = perdip[0];
					double dip = perdip[1];
					pers[j]=per;
					dips[j]=dip;
					
					//per is probability of being uni-modal; 1-prob of being multimodal
					str[j] = str[j]*(1+1.0*per);
					
					strunscaled[j]=str[j];
				}
				projections.add(projection);
				strength.add(str);
				strengthunscaled.add(strunscaled);
				dippercent.add(pers);
				dipvalue.add(dips);
			}
			
			//strength normalisieren
			BenUtil.divideMean(strength);
					
			double meanDip = BenUtil.mean(dipvalue);
			double meanVar = BenUtil.mean(strengthunscaled);
			
			//div=0;
			//average div to varianve of 1 is = ?
			for(int i=0;i<strength.size();i++){
				for(int j=0;j<strength.get(i).length;j++){
					div = div + Math.abs(1-strength.get(i)[j]);
				}
			}
			
			thea.updateCenter();
			ArrayList<double[]> center = thea.getCentres();

			//fr jeden datenpunkt die richtungen der einzelnen cluster relativ zur gewichtung, dh die distanz zum jeweiligen centrum berechnen
			ArrayList<double[]> changes = new ArrayList<double[]>();
			//Betrachten alle datenpunkte
			for(int i=0;i<thea.getDatapoints().size();i++){
				double[] datapoint = thea.getDatapoints().get(i);
				double[] now = new double[datapoint.length];
				
				//hier werden alle cluster durchgegangen fr die datenpunkte
				for(int j=0;j<directions.size();j++){
					
					double[] str = strength.get(j);
					double[] strunscaled = strengthunscaled.get(j);
					double[][] direct = directions.get(j);
					double[] centernow = center.get(j); 
					double[] dips = dipvalue.get(j);
						
					double[] relvect = BenUtil.substract(datapoint, centernow);
					//alle richtungen auf den datenpunkt wirken sich aus
					for(int l=0;l<direct.length;l++){
												
						double[] direction = direct[l];
						
						//geht mit der formel nur weil direction schon normiert ist.
						double[] pro = BenUtil.projeziereAuf(relvect, direction);
						
						//wie weit ist der datenpunkt von dem center bzgl des einflusses entfernt 
						double ver = BenUtil.norm(pro);
						//double mo = (ver/str[l]);
						//double mo = ver*(dips[l]/meanDip)/(Math.exp(ver/strunscaled[l]/divi));
						
						double mo = 0;
						if(exp){
							mo = (ver)/(Math.exp(ver/strunscaled[l]/divi));
						} else {
							mo = strunscaled[l]*divi*Math.log((ver/strunscaled[l]/divi)+1);
						}

						pro = BenUtil.normalize(pro);
						//pro = BenUtil.mult(pro, ver);
						
						//berechnen hier quasi das vorzeichen der bewegung. bei varianz kleiner 1 (relativ zu den anderen ausbreitungen), wird das ganze negativ und der cluster wird in der richtung zusammengezogen. Grer 1 wird auseinandergezogen				
						double stre = 1/str[l]-1;
						
						
						double verschiebum = stre*mo;
						if(halved){
							verschiebum = verschiebum/2;
						}
						//verlangsame den gesamten prozess
						//verschiebum = verschiebum*ver;

						//sammeln die gesamten verschiebungen, die auf den datenpunkt datapoint ausgefhrt werden sollen
						now = BenUtil.add(now, BenUtil.mult(pro, verschiebum));
						//now = BenUtil.add(now, pro);
					}
				}
				//BenUtil.print(now);
				changes.add(now);
			}

			//hier werden die gesamten nderungen, die gesammelt wurden tatschlich ausgefhrt. die gesamt-nderungs vektor kommt zum datenpunkt hinzu
			for(int i=0;i<thea.getDatapoints().size();i++){
				double[] no = thea.getDatapoints().get(i);
				no = BenUtil.add(no,changes.get(i));
				
			}
			//BenUtil.print(thea.getDatapoints().get(3));
			
			double bbb = thea.runKMEANS(thea, corr, 100, kk,false);
			//System.out.println("final nmi: "+bbb);
			return bbb;
	}

	public void scaleAlongPCA(){		
		ArrayList<double[]> data = this.getDatapoints();
		
		double[][] dir = new double[this.getDimension()][this.getDimension()];
		double[][] pointsArray = new double[this.getDatapoints().size()][this.getDimension()];
		
		for(int j=0;j<this.getDatapoints().size();j++){
			pointsArray[j]=this.getDatapoints().get(j);
		}
		    
		//create real matrix
			
		RealMatrix realMatrix = MatrixUtils.createRealMatrix(pointsArray);
		Covariance covariance = new Covariance(realMatrix);
		RealMatrix covarianceMatrix = covariance.getCovarianceMatrix();
			
		EigenDecomposition ed = new EigenDecomposition(covarianceMatrix);
		
		for(int J = 0;J<ed.getRealEigenvalues().length;J++){
			dir[J]=ed.getEigenvector(J).toArray();
		}
		
		double[][] projection = new double[this.getDimension()][this.getDimension()];
		double[] str = new double[this.getDimension()];
		
		for(int j=0;j<dir.length;j++){
			double[] proj = BenUtil.getProjection(data, dir[j]);
			projection[j] = proj;
			double var = BenUtil.getVariance(proj);
			str[j] = Math.sqrt(var);
			double per = BenUtil.DipPercent(proj);
			str[j] = str[j]*(1+(this.getKcluster()*per));
		}
		
		//apply the scaling
		ArrayList<double[]> changes = new ArrayList<double[]>();
		//Betrachten alle datenpunkte
		for(int i=0;i<data.size();i++){
			double[] datapoint = data.get(i);
			double[] now = new double[datapoint.length];
			
			//hier werden alle cluster durchgegangen fr die datenpunkte
			for(int j=0;j<str.length;j++){
				
				double strnow = str[j];
				double[] direct = dir[j];
					
				//geht mit der formel nur weil direction schon normiert ist.
				double[] pro = BenUtil.projeziereAuf(datapoint, direct);
					
				//wie weit ist der datenpunkt von dem center bzgl des einflusses entfernt 
				double ver = BenUtil.norm(pro);
				
				pro = BenUtil.normalize(pro);
				//berechnen hier quasi das vorzeichen der bewegung. bei varianz kleiner 1 (relativ zu den anderen ausbreitungen), wird das ganze negativ und der cluster wird in der richtung zusammengezogen. Grer 1 wird auseinandergezogen				
				double stre = 1/strnow-1;
					
				double verschiebum = stre*ver;
				
				//sammeln die gesamten verschiebungen, die auf den datenpunkt datapoint ausgefhrt werden sollen
				now = BenUtil.add(now, BenUtil.mult(pro, verschiebum));
			}
			changes.add(now);
		}

		//hier werden die gesamten nderungen, die gesammelt wurden tatschlich ausgefhrt. die gesamt-nderungs vektor kommt zum datenpunkt hinzu
		for(int i=0;i<data.size();i++){
			double[] no = data.get(i);
			no = BenUtil.add(no,changes.get(i));
		}
		
	}
	

	public static int analyzeMinima(String dataSet, boolean comment) throws Exception {

		//double absolutminsse = setssse[index];
		DipKM thea = new DipKM(dataSet,true);
		int k = BenUtil.getK(dataSet);
		thea.setKcluster(k);
		int[] corr = thea.association();
		//System.out.println();
		//System.out.println(dataSet);
		//System.out.println(absolutminsse);
		int iter = 1000;
		Double[] list = new Double[iter];
		double[][] ergeb = new double[iter][2];
		for(int i=0;i<1000;i++){
			double[] aa = DipKM.kMeanSSEandNMI(thea, k, corr);
			ergeb[i]=aa;
			list[i]=aa[0];
		}
		Set<Double> strSet1 = Arrays.stream(list).collect(Collectors.toSet());
		if(comment){
			double div=1;
			System.out.print("aa = {");
			for(int i=0;i<iter-1;i++){
				//System.out.printf("%.4f,"+" ", (aa));
				//System.out.printf("{"+ergeb[i][0]+","+ergeb[i][1]+"},");
				System.out.printf("{%.2f,%.7f},",ergeb[i][0]/div,ergeb[i][1]);
			}
			System.out.printf("{%.2f,%.7f}};",ergeb[iter-1][0]/div,ergeb[iter-1][1]);
			System.out.println();
			System.out.print("bb = {");
			for(int i=0;i<iter-1;i++){
				System.out.printf("%.2f,", ergeb[i][0]/div);
			}
			System.out.printf("%.2f};", ergeb[iter-1][0]/div);
			System.out.println();
			System.out.println("Different results: "+strSet1.size());
			System.out.println(strSet1);
			System.out.println("Min: "+Collections.min(strSet1));
			System.out.println("Max: "+Collections.max(strSet1));
		}
		
		return strSet1.size();
	}
	
	public static double kMeanSSE(DipKM thea, int k) {
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(k, -1, null);
		int[] lab = te.getLabel();
		double[][] center = te.getCentroids();
		double SSE=0;
		for(int i=0;i<thea.getDatapoints().size();i++){
			int label = lab[i];
			double[] localCent = center[label];
			SSE = SSE + BenUtil.normsquared(localCent,thea.getDatapoints().get(i));
		}
		if(Double.isNaN(SSE)){
			return DipKM.kMeanSSE(thea, k);
		}
		return SSE;
	}
	

	public static double[] kMeanSSEandNMI(DipKM thea, int k, int[] corr) {
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(k, -1, null);
		int[] lab = te.getLabel();
		double[][] center = te.getCentroids();
		double SSE=0;
		for(int i=0;i<thea.getDatapoints().size();i++){
			int label = lab[i];
			double[] localCent = center[label];
			SSE = SSE + BenUtil.normsquared(localCent,thea.getDatapoints().get(i));
		}
		
		double NMI = BenUtil.NMI(lab, corr);		
		
		if(Double.isNaN(SSE)){
			return DipKM.kMeanSSEandNMI(thea, k, corr);
		}
		double[] reto = new double[2];
		reto[0] = SSE;
		reto[1] = NMI;
		return reto;
	}
	
	//make a local pca on the cluster cl and return the directions, i.e. the eigenvectors.
	//If not enough data points, then return the 
	private static double[][] computeDirection(Cluster cl, DipKM thea) {
		double[][] dir = new double[thea.getDimension()][thea.getDimension()];
		double[][] pointsArray = new double[cl.size()][thea.getDimension()];
		
		//BenUtil.print(thea.getDatapoints());
		
		for(int j=0;j<cl.size();j++){
			pointsArray[j]=cl.get(thea, j);
		}
		    
		//create real matrix
		if(cl.size()>thea.getDimension()){
			
			RealMatrix realMatrix = MatrixUtils.createRealMatrix(pointsArray);
			Covariance covariance = new Covariance(realMatrix);
			RealMatrix covarianceMatrix = covariance.getCovarianceMatrix();
			
			EigenDecomposition ed = new EigenDecomposition(covarianceMatrix);
		
			for(int J = 0;J<ed.getRealEigenvalues().length;J++){
				dir[J]=ed.getEigenvector(J).toArray();
			}
		} else {
			for(int J = 0;J<dir.length;J++){
				double[] dd = new double[thea.getDimension()];
				dd[J]=1;
				dir[J] = dd;
			}
		}
		
		return dir;
	}

	public void fillCluster(int[] la) {
		int max = BenUtil.max(la);
		//BenUtil.print(la);
	
		if(max>=this.getCluster().size()){
			while(max>=this.getCluster().size()){
				Cluster cl = new Cluster();
				this.getCluster().add(cl);				
			}
		}
		
		for(int i=0;i<la.length;i++){
			this.getCluster().get(la[i]).add(i);
		}
		
		/*this.datapoints.add(add);
		int index = this.datapoints.indexOf(add);
		while(clu>=this.getCluster().size()){
			this.getCluster().add(new Cluster());
		}
		this.getCluster().get(clu).add(index);
		*/
	}
	

	public void removeEmptyCluster() {
		ArrayList<Cluster> cl = this.getCluster();
		for(int i=0;i<cl.size();i++){
			if(cl.get(i).size()<1){
				cl.remove(i);
				i--;
			}
		}
	}

	
	public void normalize() {
		for(int i=0;i<this.getDimension();i++){
			double min = this.getDatapoints().get(0)[i];
			double max = this.getDatapoints().get(0)[i];
			for(int j=0;j<this.getDatapoints().size();j++){
				double now = this.getDatapoints().get(j)[i];
				if(now<min){
					min=now;
				}
				if(now>max){
					max=now;
				}
			}
			for(int j=0;j<this.getDatapoints().size();j++){
				this.getDatapoints().get(j)[i]=(this.getDatapoints().get(j)[i]-min)/(max-min);
			}
		}
	}
	
	
	public double[] getDirection(){ 
		double[][] in = DipKM.kMeansResultCenter(this, 2);		
		double[] vect = new double[this.getDimension()];
		for(int i=0;i<vect.length;i++){
			vect[i]=in[0][i]-in[1][i];
		}
		BenUtil.normalize(vect);
		return vect;
	}

	public double[] getProjection(double[] direction) {
		double[] proj = new double[this.getDatapoints().size()];
		for(int i=0;i<proj.length;i++){
			proj[i] = BenUtil.dot(direction, this.getDatapoints().get(i));
		}
		return proj;
	}
	

	public void shiftBy(double[] mini) {
		for(int i=0;i<this.getDatapoints().size();i++){
			double[] now = this.getDatapoints().get(i);
			now = BenUtil.substract(now,mini);
		}
	}
	
	public static double relDistVectorCenter(double[] relvect, double[] direction){
		double[] pro = BenUtil.projeziereAuf(relvect, direction);
		return BenUtil.norm(pro);
	}

	public void stretchInDirectionBy(double[] direction, double dip, double[] proj) {
		int maxI = BenUtil.IndexMax(proj);
		int minI = BenUtil.IndexMin(proj);
		double min = proj[minI];
		double max = proj[maxI];
		
		for(int i=0;i<this.getDatapoints().size();i++){
			double[] now = this.getDatapoints().get(i);
			double nol = (proj[i]-min)/(max-min)*dip-proj[i];
			double[] offset = BenUtil.mult(direction,nol);
			now = BenUtil.add(now,offset);
		}
	}
	

	public static void turnDipScale(DipKM thea,double ar, int id) throws Exception{
		double[] center = thea.getCentres().get(id-1);
		ar=0.01745*ar;
		ArrayList<double[]> data = thea.getDatapoints();
		double sinalpha = Math.sin(ar);
		double cosalpha = Math.cos(ar);
		int[] ass = thea.association();
		for(int k=0;k<data.size();k++){
			if(ass[k]==id){
				double[] old = data.get(k);
				double adoi=old[0]-center[0];
				double adoj=old[1]-center[1];
				old[0]=adoi*cosalpha-adoj*sinalpha+center[0];
				old[1]=adoi*sinalpha+adoj*cosalpha+center[1];
			}
		}
	}
	
	public static void turnDipScale(DipKM thea,double ar, int i, int j) throws Exception{
		ar=0.01745*ar;
		ArrayList<double[]> data = thea.getDatapoints();

		double sinalpha = Math.sin(ar);
		double cosalpha = Math.cos(ar);
		
		for(int k=0;k<data.size();k++){
			double[] old = data.get(k);
			double adoi=old[i];
			double adoj=old[j];
			old[i]=adoi*cosalpha-adoj*sinalpha;
			old[j]=adoi*sinalpha+adoj*cosalpha;
		}
	}
	
	public static void moveCluster(DipKM thea, int i, int j, int id) {
		ArrayList<double[]> data = thea.getDatapoints();
		int[] ass = thea.association();
		for(int k=0;k<data.size();k++){
			if(ass[k]==id){
				double[] old = data.get(k);
				old[0]=old[0]+i;
				old[1]=old[1]+j;
			}
		}
	}



	static double[] copyFeature(DipKM temp, int remdim) {
		double[] reto = new double[temp.getDatapoints().size()];
		for(int i=0;i<reto.length;i++){
			reto[i]=temp.getDatapoints().get(i)[remdim];
		}
		return reto;
	}

	public static DipKM removeFeature(DipKM thea, int di, int[] corr) throws Exception {
		ArrayList<double[]> da = new ArrayList<double[]>();
		int dim = thea.getDatapoints().get(0).length;
		for(int o=0;o<thea.getDatapoints().size();o++){
			double[] now = thea.getDatapoints().get(o);
			double[] ado = new double[dim-1];
			for(int i=0;i<di;i++){
				ado[i]=now[i];
			}
			for(int i=di;i<dim-1;i++){
				ado[i]=now[i+1];
			}
			da.add(ado);
		}
		DipKM neo = new DipKM(da,corr);
		return neo;
	}

	public DipKM copy() throws Exception{
		int d = this.getDimension();
		int n = this.getDatapoints().size();
		int[] ass = this.association();
		ArrayList<double[]> newdata = new ArrayList<double[]>();
		for(int i=0;i<n;i++){
			double[] neo = Arrays.copyOf(this.getDatapoints().get(i), d);
			newdata.add(neo);
		}
		DipKM reto = new DipKM(newdata,ass);
		return reto;
	}

	public static void turnDipKM(DipKM thea,double ar, int i, int j) throws Exception{
		ar=0.01745*ar;
		ArrayList<double[]> data = thea.getDatapoints();

		double sinalpha = Math.sin(ar);
		double cosalpha = Math.cos(ar);
		
		for(int k=0;k<data.size();k++){
			double[] old = data.get(k);
			double adoi=old[i];
			double adoj=old[j];
			old[i]=adoi*cosalpha-adoj*sinalpha;
			old[j]=adoi*sinalpha+adoj*cosalpha;
		}
	}
	
	// plottet die histogramme aller dimensionen
	public static void HistoPlot(DipKM thea) {
		int k = thea.getDimension();
		for(int i=0;i<k;i++){
			Paint.plot(thea, i,""+i);
		}
	}

	// plottet alle 2-subsets des datensatzes 
	public static void PairPlot(DipKM thea) throws Exception {
		int dim = thea.getDimension();
		for(int i=0;i<dim;i++){
			for(int j=i+1;j<dim;j++){
				Paint.plot(thea,i,j,""+i+"  "+j);
			}
		}
	}

	public static double normKMEANS(DipKM thea,String name, int[] corr, int iter, int k) throws IOException {
		thea.normalize();
		
		double nmi=0;
		for(int i=0;i<iter;i++){
			KMmain te = new KMmain(thea.getDatapoints());
			te.clustering(k, 100, null);
			int[] lab = te.getLabel();
			double aa = BenUtil.NMI(corr, lab);
			nmi=nmi+aa;
			BenUtil.saveLabels(lab, name+""+(i+1)+"_znorm");
		}
		System.out.println("Normed NMI: "+(nmi/iter));
		return (nmi/iter);
		
	}
	
	public static void scale(DipKM thea, double[] scale) {
		for(int i=0;i<thea.getDimension();i++){
			double min = thea.getDatapoints().get(0)[i];
			double max = thea.getDatapoints().get(0)[i];
			for(int j=0;j<thea.getDatapoints().size();j++){
				double now = thea.getDatapoints().get(j)[i];
				if(now<min){
					min=now;
				}
				if(now>max){
					max=now;
				}
			}
			for(int j=0;j<thea.getDatapoints().size();j++){
				thea.getDatapoints().get(j)[i]=(thea.getDatapoints().get(j)[i]-min)/(max-min)*scale[i];
			}
		}
	}
	
	public static void DipScale(DipKM thea) {
		double[] scale = DipKM.computeDipValues(thea.getDatapoints());
		DipKM.scale(thea, scale);
	}
	
	public static double[] computeDipValues(ArrayList<double[]> datapoints) {
		double[] dipValues = new double[datapoints.get(0).length];	
		double[] tempValues = new double[datapoints.size()];	
		for(int j=0;j<dipValues.length;j++){
			for(int i=0;i<tempValues.length;i++){
				tempValues[i] = datapoints.get(i)[j];
			}
			Arrays.sort(tempValues);
			double[] at = DipKM.DipTest(tempValues);
			dipValues[j] = at[0];
		}
		return dipValues;
	}

	public static void computePercent(double[] scale, ArrayList<Integer> indices, ArrayList<double[]> here, double d) {
		double[] tempDipValues = new double[here.size()];	
		
		for(int j=0;j<here.get(0).length;j++){
			for(int i=0;i<tempDipValues.length;i++){
				tempDipValues[i]=here.get(i)[j];
			}
			Arrays.sort(tempDipValues);
			double[] at = DipKM.DipTest(tempDipValues);
			if(at[1]<d){
				indices.add(j);
			}
			scale[j]=at[1];
		}
	}
	
	public static void computeDipAndPercentValue(double[] dip,double[] percent, ArrayList<double[]> here) {
		double[] tempDipValues = new double[here.size()];	
		
		for(int j=0;j<here.get(0).length;j++){
			for(int i=0;i<tempDipValues.length;i++){
				tempDipValues[i]=here.get(i)[j];
			}
			Arrays.sort(tempDipValues);
			double[] at = DipKM.DipTest(tempDipValues);
			dip[j]=at[0];
			percent[j]=at[1];
		}
	}
	
	public static double runKMEANS(DipKM thea, int[] corr, int iter, int k) {
		return DipKM.runKMEANS(thea, corr, iter, k, true);
	}
	
	public static double runKMEANS(DipKM thea, int[] corr, int iter, int k,Boolean set) {
		double nmi=0;
		for(int i=0;i<iter;i++){
			KMmain te = new KMmain(thea.getDatapoints());
			te.clustering(k, 100, null);
			int[] lab = te.getLabel();
			
			double aa = BenUtil.NMI(corr, lab);
			nmi=nmi+aa;
			//System.out.printf("%.3f,"+" ", (aa));
		}
		if(set){
			System.out.printf("%.3f\n", (nmi/iter));
		}
		//System.out.println("Kmeans NMI: "+(nmi/iter));
		return nmi/iter;
	}
	
	public static int[] kMeansResult(DipKM thea, int k, int iter) {
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(k, iter, null);
		int[] lab = te.getLabel();
		return lab;
	}
	
	public static int[] kMeansResult(DipKM thea, double[][] center, int iter) {
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(center.length, iter, center);
		int[] lab = te.getLabel();
		return lab;
	}
	
	public static int[] kMeansResult(DipKM thea, int k) {
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(k, 100, null);
		int[] lab = te.getLabel();
		return lab;
	}
	
	public static int[] kMeansResult(DipKM thea, double[][] center) {
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(center.length, 100, center);
		int[] lab = te.getLabel();
		return lab;
	}

	public static double[][] kMeansResultCenter(DipKM thea, int k) {
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(k, 100, null);
		double[][] lab = te.getCentroids();
		return lab;
	}

	public static double[] KmeansStreuung(String dataSet, int iter) throws Exception {
		return KmeansStreuung(dataSet,iter,true);
	}
	
	public static double[] KmeansStreuung(String dataSet, int iter,Boolean set) throws Exception {
		DipKM thea = new DipKM(dataSet,true);
		int[] corr = thea.association();
		int k=BenUtil.getK(dataSet);
		double[] streuung = new double[iter];
		
		
		double nmi=0;
		if(set){
			System.out.print("aa={");
		}
		for(int i=0;i<iter-1;i++){
			KMmain te = new KMmain(thea.getDatapoints());
			te.clustering(k, 100, null);
			int[] lab = te.getLabel();
			
			double aa = BenUtil.NMI(corr, lab);
			nmi=nmi+aa;
			if(set){
				System.out.printf("%.4f,"+" ", (aa));
			}
			streuung[i]=aa;
		}
		KMmain te = new KMmain(thea.getDatapoints());
		te.clustering(k, 100, null);
		int[] lab = te.getLabel();
		
		double aa = BenUtil.NMI(corr, lab);
		streuung[streuung.length-1]=aa;
		nmi=nmi+aa;
		if(set){
			System.out.printf("%.3f"+" ", (aa));
			System.out.println("};");
		}
		return streuung;
	}

	public static double[] DipTest(double[] data){
		if(data.length<=5){
			double[] reto = new double[4];
			reto[0]=0;reto[1]=1;
			reto[2]=0; reto[3]=data.length-1;
			return reto;
		}
		double[] at = jdistlib.disttest.DistributionTest.diptest(data);
		return at;
	}
	
	public static void dipPrint(double[] at, double[] ad, int a) {
		System.out.println(at[0]);
		System.out.println(at[1]);
		System.out.println("in "+(at[2]+a));
		System.out.println("in "+(at[3]+a));
		if(at[2]>0){
			System.out.println(ad[(int) (at[2]+a)]);
		}
		if(at[3]>0){
			System.out.println(ad[(int) (at[3]+a)]);
		}
	}
	

	public static double[] mean(ArrayList<double[]> current) throws Exception	{
		if(current.size()==0){
			// System.out.println("Error! No Data points in Cluster!");
			throw new Exception("Error! No Data points in Cluster");
		}
		double[] reto = new double[current.get(0).length];
		for(int i=0;i<reto.length;i++){
			for(int j=0;j<current.size();j++){
				reto[i]=reto[i]+current.get(j)[i];
			}
		}
		for(int i=0;i<reto.length;i++){
			reto[i]=reto[i]/current.size();
		}
		return reto;
	}
	

	public ArrayList<double[]> getClusterData(int j) {
		ArrayList<Integer> punkte = this.getCluster().get(j).getPunkte();
		ArrayList<double[]> dat = new ArrayList<double[]>();
		for(int i=0;i<punkte.size();i++){
			dat.add(this.getDatapoints().get(punkte.get(i)));
		}
		return dat;
	}
	
	public void updateCenter(int i){
		this.getCluster().get(i).calculateCenterAuto(this);
	}
	
	public void updateCenter(){
		for(int i=0;i<this.getCluster().size();i++){
			this.updateCenter(i);
		}
		this.getCentres().clear();
		for(int i=0;i<this.getCluster().size();i++){
			double[] now = this.getCluster().get(i).getCenter();
			this.getCentres().add(now);
		}
		
	}
	
	public void data2center() {
		this.emptyCluster();
		ArrayList<double[]> centers = this.centres;
		ArrayList<double[]> data = this.getDatapoints();

		for(int i=0;i<data.size();i++){
			int l = BenUtil.minDist(data.get(i),centers);
			this.getCluster().get(l).add(i);
		}
		for(int i=0;i<this.getCluster().size();i++){
			this.getCluster().get(i).setCenter(centers.get(i));
		}
	}
	

	public double[][] findBorders(){
		double[][] border = new double[this.getDimension()][2];
		ArrayList<double[]> data = this.getDatapoints();
		int dim = this.getDimension();
		for(int j=0;j<dim;j++){
			border[j][0]=data.get(0)[j];
			border[j][1]=data.get(0)[j];
		}
		
		for(int i=0;i<data.size();i++){
			double[] now = data.get(i);
			for(int j=0;j<dim;j++){
				if(border[j][0]>now[j]){
					border[j][0]=now[j];
				}
				if(border[j][1]<now[j]){
					border[j][1]=now[j];
				}
			}
		}
		
		return border;
	}
	
	private void setBorders() {
		this.borders = this.findBorders();
	}

	
	public int getID(int dre){
		for(int i=0;i<this.getCluster().size();i++){
			if(this.getCluster().get(i).getPunkte().contains(dre)==true){
				return i;
			}
		}
		return -1;
	}
	
	public int[] association(){
		int[] reto = new int[this.getDatapoints().size()];
		for(int i=0;i<this.getDatapoints().size();i++){
			reto[i]=this.getID(i);
		}
		return reto;	
	}
	
	
	public boolean ClustercontainsDataPoint(int maybe) {
		ArrayList<Cluster> clu = this.getCluster();
		Boolean reto = false;
		for(int i=0;i<clu.size();i++){
			if(clu.get(i).getPunkte().contains(maybe)==true){
				//System.out.println(i);
				return true;
			}
		}
		return reto;
	}
	
	public ArrayList<double[]> getCentres() {
		return centres;
	}

	public void setCentres(ArrayList<double[]> centres) {
		this.centres = centres;
	}

	public ArrayList<Cluster> getCluster() {
		return cluster;
	}

	public void setCluster() {
		ArrayList<Cluster> ado = new ArrayList<Cluster>();
		Cluster cl = new Cluster();
		for(int i=0;i<this.getDatapoints().size();i++){
			cl.add(i);
		}
		ado.add(cl);
		this.cluster = ado;
	}
	

	public void setCluster(int[] label) {
		ArrayList<Cluster> ado = new ArrayList<Cluster>();
		int unique = BenUtil.unique(label);
		for(int i=0;i<unique;i++){
			Cluster cl = new Cluster();
			
			for(int j=0;j<label.length;j++){
				if(label[j]==i){
					cl.add(j);
				}
			}
			ado.add(cl);
		}
		
		this.cluster = ado;
	}
	
	public void setCluster(ArrayList<Cluster> cluster) {
		this.cluster = cluster;
	}

	public ArrayList<double[]> getDatapoints() {
		return datapoints;
	}

	public void setDatapoints(ArrayList<double[]> datapoints) {
		this.datapoints = datapoints;
	}
	
	public void addData(double[] add) {
		this.datapoints.add(add);
	}
	
	//we add the double[] to the regular data and save its index in the corresponding cluster
	public void addClusterIndex(double[] add, int clu) {
		this.datapoints.add(add);
		int index = this.datapoints.indexOf(add);
		while(clu>=this.getCluster().size()){
			this.getCluster().add(new Cluster());
		}
		this.getCluster().get(clu).add(index);
	}
	
	public int getDimension() {
		return dim;
	}

	public void setDimension(int dimension) {
		this.dim = dimension;
	}

	public int getKcluster() {
		return k;
	}

	public void setKcluster(int k) {
		this.k = k;
	}

	public double[][] getBorders() {
		return borders;
	}

	public void setBorders(double[][] ds) {
		this.borders = ds;
	}


	public void emptyCluster() {
		for(int i=0;i<this.getCluster().size();i++){
			this.getCluster().get(i).clear();
		}
	}
	
	/*public static void moveCluster(DipKM thea, int i, int j, int id) {
		ArrayList<double[]> data = thea.getDatapoints();
		int[] ass = thea.association();
		for(int k=0;k<data.size();k++){
			if(ass[k]==id){
				double[] old = data.get(k);
				old[0]=old[0]+i;
				old[1]=old[1]+j;
			}
		}
	}*/

	public static void runTheRunningExample() throws Exception {
		Boolean random = false;
		Boolean halved = true;
		Boolean exp = true;
		Boolean normalize = true; 

		String dataSet = "runEx";
		int kk = BenUtil.getK(dataSet);
		//kk=10;
		DipKM thea = new DipKM(dataSet);
		thea.normalize();
		int[] corr = thea.association();
		
		Paint.plot(thea);
		Thread.sleep(1000);
		
		Boolean plot = true;
		Boolean comment = false;
		thea.setBorders(thea.findBorders());
		thea.setKcluster(kk);
		thea.updateCenter();
		
		System.out.print("NMI on the norm. dataset:");
		double a = DipKM.runKMEANS(thea, corr, 100, kk); 
		
		double[][] startcenter = new double[kk][];
		startcenter[0]=thea.getDatapoints().get(0);
		startcenter[3]=thea.getDatapoints().get(100);
		startcenter[2]=thea.getDatapoints().get(300);
		startcenter[1]=thea.getDatapoints().get(600);
		startcenter[4]=thea.getDatapoints().get(800);
		
		//double tot = 0;
		//for(int i=0;i<100;i++){
					thea = new DipKM(dataSet);
					thea.normalize();
					int[] lala = DipKM.tempMethod4(thea,kk, corr, plot, comment,10, random, halved, exp, normalize, startcenter);
					double zt = BenUtil.NMI(lala, corr);
					//tot = tot+zt;
					System.out.println("NMI is after transformation: "+zt);
		//}

		//System.out.println(tot/100);
		thea.setBorders(thea.findBorders());
		Paint.plot(thea);
	}
	
	public static void runthemAll(String[] tt) throws Exception {
		Boolean random = false;
		Boolean halved = true;
		Boolean exp = true;
		Boolean normalize = true; 
		int howoften=100;
		for(int lauf = 0;lauf<tt.length;lauf++){
			String dataSet =tt[lauf];
			System.out.println(dataSet);
			double rrr = 0;
			double ttt = 0;
			
			//double ggg = 0;
			int kk = BenUtil.getK(dataSet);
			//System.out.println(kk);
			double div = howoften;
			DipKM thea = new DipKM(dataSet);
			if(normalize){
				thea.normalize();
			}
			thea.setBorders(thea.findBorders());
			thea.setKcluster(kk);
			//double zu = DipKM.runKMEANS(thea, thea.association(), 100, kk,false);
			double nmikmeans = 0;
			
			ArrayList<Double> erg = new ArrayList<Double>();
			double nnnn = 0;
			for(int l=1;l<howoften+1;l++){
				int[] startlabel = BenUtil.readLabelCSV(dataSet+"Norm_kmeans"+l);
				thea = new DipKM(dataSet);
				thea.setBorders(thea.findBorders());
				thea.setKcluster(kk);
				int[] corr = thea.association();
				nmikmeans = nmikmeans + BenUtil.NMI(startlabel, corr);
				Boolean plot = false;
				Boolean comment = false;
				
				try{
					int[] lala = DipKM.tempMethod4(thea,kk, corr, plot, comment,10, random, halved, exp, normalize, startlabel);
					double zt = BenUtil.NMI(lala, corr);
					ttt = ttt + zt;
					erg.add(zt);
					//BenUtil.saveLabels(lala, dataSet+"norm_AAA"+""+(l));
					//BenUtil.save(thea,corr, dataSet+"AAA"+(l+1));
					
				}
				catch(Exception e){
					//System.out.println("prob");
					//div = div -1;
					Boolean error = true;
					while(error){
						try{
							thea = new DipKM(dataSet);
							thea.setBorders(thea.findBorders());
							thea.setKcluster(kk);
							int[] lala = DipKM.tempMethod4(thea,kk, corr, plot, comment,10, random, halved, exp, normalize);

							double zt = BenUtil.NMI(lala, corr);
							//BenUtil.saveLabels(lala, dataSet+"norm_AAA"+""+(l));
							//BenUtil.save(thea,corr, dataSet+"AAA"+(l+1));
							
							ttt = ttt + zt;
							erg.add(zt);
							error=false;
						}
						catch(Exception f){
							//div = div -1;
						}
					}
				}
				
			}
			System.out.printf("NMI on the normalized data set: %.4f"+" ", (nmikmeans/howoften));
			System.out.println();
			System.out.printf("NMI after our Transformation: %.4f"+"  ", (ttt/div));

			System.out.println();
			System.out.println();
		}
	}

	public static void RecomputeNMI(String[] tt) throws Exception {
		System.out.println("Recomputing NMI. PCE is here called AAA, as the name was the last thing to get decided");
		String[] comp = {"_AAA","_kmeans","Dip_kmeans","zero_kmeans","PCA_kmeans","ICA_kmeans","_kmeansplusplus","_spec","_stsc","_idec","_dec","_dipmeans","_synC","_DBSCAN","_singleLinkComplete","_EM","_FossClu","_FossClu","_subKMeans","_kernelkmpoly","_kernelkmGauss", "_EWKM"};
		//
		for(int j=0;j<comp.length;j++){
			for(int i=0;i<tt.length;i++){
				String dataSet = tt[i];
				dataSet = dataSet +"norm";
				String tested = dataSet+comp[j];
				DipKM.DoNMI(dataSet, tested);
			}
			System.out.println();
		}
	}
	

	public static void RecomputeNMIrunningExample(String string) throws Exception {
		System.out.println("Recomputing NMI. PCE is here called AAA, as the name was the last thing to get decided");
		String[] comp = {"_AAA","_kmeans","Dip_kmeans","zero_kmeans","PCA_kmeans","ICA_kmeans","_kmeansplusplus","_spec","_stsc","_idec","_dec","_dipmeans","_synC","_DBSCAN","_singleLinkComplete","_EM","_subKMeans","_kernelkmpoly","_kernelkmGauss", "_EWKM"};
		//String[] comp = {"_DBSCAN", "_EWKM"};
		//String[] comp = {"_kernelkmpoly","_kernelkmGauss"};
		
		for(int j=0;j<comp.length;j++){
			for(int i=0;i<1;i++){
				String dataSet = string;
				String tested = dataSet+comp[j];
				DipKM.DoNMI(dataSet, tested);
			}
			System.out.println();
		}
	}
	
	
	public static void DoNMI(String dataSet, String tested) throws Exception{
		//for(int j=0;j<ttc.length;j++){
			
			//String dataSet =ttc[j];
			//dataSet = dataSet+"norm";
			DipKM thea = new DipKM(dataSet,true);
			int k = BenUtil.getK(dataSet);
			//System.out.println(dataSet);
			int[] label = thea.association();
			
			System.out.println(tested);
			if(tested.contains("_fuse") ||tested.contains("_AAA")  ||tested.contains("_kernelkmGauss")  ||tested.contains("_kernelkmpoly") ||tested.contains("_EWKM") ||tested.contains("AAA_singleLinkComplete") ||tested.contains("_EM") ||tested.contains("plusplus") ||tested.contains("_DipScaling") ||tested.contains("_spec")|| tested.contains("_pca") || tested.contains("_ica") || tested.contains("_tsne") || tested.contains("_proclus") || tested.contains("_clique") || tested.contains("_kmeans")){
				double nm = 0;
				double[] nn = new double[100];
				for(int iter = 1;iter<101;iter++){
					int[] laba = BenUtil.readLabelCSV(tested+""+iter);
					int off = BenUtil.min(laba);
					for(int i=0;i<laba.length;i++){
						laba[i]=laba[i]-off+1;
					}
					nn[iter-1]=BenUtil.NMI(laba, label);
					nm=nm+ BenUtil.NMI(laba, label);
					//System.out.println(BenUtil.NMI(laba, label));
				}
				
				//System.out.println(BenUtil.getStdDev(nn));
				System.out.printf("%.4f"+" ", (nm/(100)));
				System.out.println();
			}else if(tested.contains("_idec")|| tested.contains("_dec")){
				double nm = 0;
				double[] nn = new double[10];
				for(int iter = 1;iter<11;iter++){
					int[] laba = BenUtil.readLabelCSV(tested+""+iter);
					int off = BenUtil.min(laba);
					for(int i=0;i<laba.length;i++){
						laba[i]=laba[i]-off+1;
					}
					nn[iter-1]=BenUtil.NMI(laba, label);
					nm=nm+ BenUtil.NMI(laba, label);
					//System.out.println(BenUtil.NMI(laba, label));
				}
				
				//System.out.println(BenUtil.getStdDev(nn));
				System.out.println(nm/(10));
			}else if(tested.contains("skinny")){ 
				//DipScale thear = new DipScale(dataSet+"_skinnydipTrans",true);
				//thea = new DipScale(dataSet,true);
				//thear.updateCenter();
				//thear.data2center();
				//BenUtil.saveLabels(thear, dataSet+"_skinnyDip");
				//System.out.println(BenUtil.NMI(thear, thea));
				int[] laba = BenUtil.readLabelCSV(tested);
				int off = BenUtil.min(laba);
				for(int i=0;i<laba.length;i++){
					laba[i]=laba[i]-off+1;
				}
				double nmi = BenUtil.NMI(laba, label);
				System.out.println(nmi);		
			}else if(tested.contains("DBSCAN")){
				double nm = 0;
				int[] a = {1,2,3,5,10,50};
				int[] b = {1,2,3,4,5,6,7};
				double nmi=0;
				for(int i=0;i<a.length;i++){
					for(int l=0;l<b.length;l++){
						String test = tested+""+a[i]+"-"+b[l]+"";
						//System.out.println(test);
						int[] laba = BenUtil.readLabelCSV(test+"");
						int off = BenUtil.min(laba);
						for(int kk=0;kk<laba.length;kk++){
							laba[kk]=laba[kk]-off+1;
						}
						nm=BenUtil.NMI(laba, label);		
						if(nm>nmi){
							nmi=nm;
						}
					}
				}
				System.out.println(nmi);
			}else {
				int[] laba = BenUtil.readLabelCSV(tested);
				int off = BenUtil.min(laba);
				for(int i=0;i<laba.length;i++){
					laba[i]=laba[i]-off+1;
				}
				
				double nmi = BenUtil.NMI(laba, label);
				System.out.println(nmi);
			}
		//}
	}



}
