package main;
import java.awt.AWTException;
import java.awt.BasicStroke;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Random;
import javax.imageio.ImageIO;
import javax.swing.JFrame;

@SuppressWarnings({ "serial", "unused" })
public class Paint extends Canvas {
	
	private ArrayList<double[]> datapoints;
	protected ArrayList<double[]> centres;
	protected ArrayList<double[][]> directions;
	protected ArrayList<double[]> strength;
	protected ArrayList<Cluster> clust;
	private int[] association;
	protected String style;
	protected static Color[] greyshades = new Color[256];
	protected static Color[] colour = new Color[256];
	protected double[][] border;
	public static int pixel = 5;
	protected static int height=1000;
	protected static int width=1000;
	protected int[] count;
	
    public Paint(DipKM mystuff, String norm) {
    	datapoints = mystuff.getDatapoints();
    	centres = mystuff.getCentres();
    	style = norm;
    	this.border=mystuff.getBorders();
    	this.association=mystuff.association();
    }

	public Paint(int[] counter, int[] asso, String norm) {
		style = norm;
		count = counter;
		this.association=asso;
	}

	public Paint(DipKM mystuff, int[] lab) {
		datapoints = mystuff.getDatapoints();
    	centres = mystuff.getCentres();
    	style = "all";
    	this.border=mystuff.getBorders();
    	this.association=lab;
	}
	
	public Paint(DipKM thea, ArrayList<double[][]> directions, ArrayList<double[]> strength) {
    	datapoints = thea.getDatapoints();
    	centres = thea.getCentres();
    	style = "PcaCluster";
    	this.border=thea.findBorders();
    	this.association=thea.association();
		this.directions = directions;
		this.strength = strength;
	}

	public static void initialize(int pixel){
		Paint.pixel=pixel;
    	for(int l=0; l<256;l++){
    		Paint.greyshades[l]=new Color(l,l,l);
    	}
    	Paint.colour[0]=Color.black;
    	Paint.colour[2]=Color.red;
    	Paint.colour[1]=Color.yellow;
    	Paint.colour[3]=Color.blue;
    	Paint.colour[4]=Color.pink;
    	Paint.colour[5]=Color.cyan;
    	Paint.colour[6]=Color.pink;
    	Paint.colour[7]=Color.orange;
    	Paint.colour[8]=Color.darkGray;
    	Paint.colour[9]=Color.magenta;
    	Paint.colour[10]=Color.black;
    	Random rando = new Random();
    	for(int l=10; l<256;l++){
    		int a = (int) (rando.nextFloat()*255);
    		int b = (int) (rando.nextFloat()*255);
    		int c = (int) (rando.nextFloat()*255);
    		Paint.colour[l]=new Color(a,b,c);
    		//Paint.colour[l]=Color.blue;
    	}
    	
    }
    
	private String getStil() {
		return style;
	}
	
    public void paint(Graphics gg) {
    	Graphics2D g = (Graphics2D)gg;
    	
    	if(this.getStil().equals("all")){
    		ArrayList<double[]> data = this.datapoints;
    		//double[][] borders = this.border;
    		//g.setColor(Color.black);
    		//g.drawRect(25, 25, (int)(border[0][1]-border[0][0]+50), (int)(border[1][1]-border[1][0]+50));
    		int mino = BenUtil.min(association);
    		for(int i=0;i<data.size();i++){
    			double[] now = data.get(i);
    			int col = this.association[i];
    			
    			
    			
    			double min = Math.max((border[1][1]-border[1][0]), (border[0][1]-border[0][0]));
    			int x = (int) (50+(now[0]-border[0][0])*height/min);
    			int y = (int) (50+(now[1]-border[1][0])*width/min);
    			
    			int off = 2;
    			int size = 18;
    			//if(col==1){
    				g.setColor(Color.black);
    				g.fillOval(x-off, y-off, size+2*off, size+2*off);
    				g.setColor(colour[col-mino+1]);    
    				g.fillOval(x, y, size, size);
    			//}

    		}
    		for(int i=0;i<this.centres.size();i++){
    			double[] now = this.centres.get(i);

    			/*g.setColor(Color.black);
    			double min = Math.max((border[1][1]-border[1][0]), (border[0][1]-border[0][0]));
    			int x = (int) (50+(now[0]-border[0][0])*height/min);
    			int y = (int) (50+(now[1]-border[1][0])*width/min);
    			
    			int size = 9;
    			g.setColor(Color.black);
    			g.fillOval(x-size-2, y-size-2, 2*size+4, 2*size+4);
    			g.setColor(Color.white);
    			g.fillOval(x-size, y-size, 2*size, 2*size);	
    			int s = 5;
    			g.setColor(Color.black);
    			g.fillRect(x-s-2, y-4, 2*s+5, s+4);
    			g.fillRect(x-4, y-s-2, s+4, 2*s+5);
    			g.setColor(Paint.colour[i+1]);
    			g.fillRect(x-s, y-2, 2*s+1, s);
    			g.fillRect(x-2, y-s, s, 2*s+1);*/
    		}

    	} 
    	if(this.getStil().equals("PcaCluster")){
    		ArrayList<double[]> data = this.datapoints;
    		ArrayList<double[][]> direct = this.directions;
    		ArrayList<double[]> stren = this.strength;
    		
    		double a=0; double b=0;
    		double max = 0;
    		for(int i=0;i<stren.size();i++){
    			//BenUtil.print(stren.get(i));
    			double locmax = BenUtil.max(stren.get(i));
    			if(max<locmax){
    				max=locmax;
    				a = i;
    				b = BenUtil.IndexMax(stren.get(i));
    			}
    		}
    		//System.out.println(max);
    		//System.out.println(a+"  "+b);
    		
    		int mino = BenUtil.min(association);
    		for(int i=0;i<data.size();i++){
    			double[] now = data.get(i);
    			int col = this.association[i];
    			
    			
    			double min = Math.max((border[1][1]-border[1][0]), (border[0][1]-border[0][0]));
    			int x = (int) (50+(now[0]-border[0][0])*height/min);
    			int y = (int) (50+(now[1]-border[1][0])*width/min);
    			
    			int off = 2;
    			int size = 18;
    			//if(col==0 || col==2){
    				g.setColor(Color.black);
    				g.fillOval(x-off, y-off, size+2*off, size+2*off);
    				g.setColor(colour[col-mino+1]);    
    				g.fillOval(x, y, size, size);
    			//}
    		}
    		for(int i=0;i<this.centres.size();i++){
    			//if(i==0 || i==2){
    			double[][] dir = direct.get(i);
    			double[] var = stren.get(i);
    			double[] now = this.centres.get(i);
    			
    			g.setColor(Color.black);
    			double min = Math.max((border[1][1]-border[1][0]), (border[0][1]-border[0][0]));
    			int x = (int) (50+(now[0]-border[0][0])*height/min);
    			int y = (int) (50+(now[1]-border[1][0])*width/min);
    			
    			double[] dir1 = dir[0];
    			BenUtil.norm(dir1);
    			g.setColor(Color.BLACK);
    			g.setStroke(new BasicStroke(12F));
    			g.drawLine(x, y, (int) (x+dir1[0]*80*var[0]), (int) (y+dir1[1]*80*var[0]));
    			g.drawLine(x, y, (int) (x-dir1[0]*80*var[0]), (int) (y-dir1[1]*80*var[0]));
    			g.setColor(Color.WHITE);
    			g.setStroke(new BasicStroke(9F));
    			g.drawLine(x, y, (int) (x+dir1[0]*80*var[0]), (int) (y+dir1[1]*80*var[0]));
    			g.drawLine(x, y, (int) (x-dir1[0]*80*var[0]), (int) (y-dir1[1]*80*var[0]));
    			g.setColor(Paint.colour[i+1]);    	
    			g.setStroke(new BasicStroke(6F));
    			g.drawLine(x, y, (int) (x+dir1[0]*80*var[0]), (int) (y+dir1[1]*80*var[0]));
    			g.drawLine(x, y, (int) (x-dir1[0]*80*var[0]), (int) (y-dir1[1]*80*var[0]));
    			
    			double[] dir2 = dir[1];
    			BenUtil.norm(dir1);
    			
    			g.setColor(Color.BLACK);
    			g.setStroke(new BasicStroke(12F));
    			g.drawLine(x, y, (int) (x+dir2[0]*80*var[1]), (int) (y+dir2[1]*80*var[1]));
    			g.drawLine(x, y, (int) (x-dir2[0]*80*var[1]), (int) (y-dir2[1]*80*var[1]));
    			g.setColor(Color.WHITE);
    			g.setStroke(new BasicStroke(9F));
    			g.drawLine(x, y, (int) (x+dir2[0]*80*var[1]), (int) (y+dir2[1]*80*var[1]));
    			g.drawLine(x, y, (int) (x-dir2[0]*80*var[1]), (int) (y-dir2[1]*80*var[1]));
    			g.setColor(Paint.colour[i+1]);    	
    			g.setStroke(new BasicStroke(6F));
    			g.drawLine(x, y, (int) (x+dir2[0]*80*var[1]), (int) (y+dir2[1]*80*var[1]));
    			g.drawLine(x, y, (int) (x-dir2[0]*80*var[1]), (int) (y-dir2[1]*80*var[1]));
    			
    			int size = 12;
    			g.setColor(Color.black);
    			g.fillOval(x-size-2, y-size-2, 2*size+4, 2*size+4);
    			g.setColor(Color.white);
    			g.fillOval(x-size, y-size, 2*size, 2*size);	
    			g.setColor(Color.black);
    			g.fillOval(x-size+2, y-size+2, 2*size-4, 2*size-4);	
    			g.setColor(Paint.colour[i+1]);
    			g.fillOval(x-size+4, y-size+4, 2*size-8, 2*size-8);	
    			//}
    			/*if(a==i){
    				if(b==0){
    	    			g.setColor(Color.BLACK);
    	    			g.setStroke(new BasicStroke(15F));
    	    			g.drawLine(x, y, (int) (x+dir1[0]*80*var[0]), (int) (y+dir1[1]*80*var[0]));
    	    			g.drawLine(x, y, (int) (x-dir1[0]*80*var[0]), (int) (y-dir1[1]*80*var[0]));
    	    			g.setColor(Color.WHITE);
    	    			g.setStroke(new BasicStroke(12F));
    	    			g.drawLine(x, y, (int) (x+dir1[0]*80*var[0]), (int) (y+dir1[1]*80*var[0]));
    	    			g.drawLine(x, y, (int) (x-dir1[0]*80*var[0]), (int) (y-dir1[1]*80*var[0]));
    	    			g.setColor(Paint.colour[i+1]);    	
    	    			g.setStroke(new BasicStroke(9F));
    	    			g.drawLine(x, y, (int) (x+dir1[0]*80*var[0]), (int) (y+dir1[1]*80*var[0]));
    	    			g.drawLine(x, y, (int) (x-dir1[0]*80*var[0]), (int) (y-dir1[1]*80*var[0]));
    				} else {
    	    			g.setColor(Color.BLACK);
    	    			g.setStroke(new BasicStroke(15F));
    	    			g.drawLine(x, y, (int) (x+dir2[0]*80*var[1]), (int) (y+dir2[1]*80*var[1]));
    	    			g.drawLine(x, y, (int) (x-dir2[0]*80*var[1]), (int) (y-dir2[1]*80*var[1]));
    	    			g.setColor(Color.WHITE);
    	    			g.setStroke(new BasicStroke(12F));
    	    			g.drawLine(x, y, (int) (x+dir2[0]*80*var[1]), (int) (y+dir2[1]*80*var[1]));
    	    			g.drawLine(x, y, (int) (x-dir2[0]*80*var[1]), (int) (y-dir2[1]*80*var[1]));
    	    			g.setColor(Paint.colour[i+1]);   	
    	    			g.setStroke(new BasicStroke(9F));
    	    			g.drawLine(x, y, (int) (x+dir2[0]*80*var[1]), (int) (y+dir2[1]*80*var[1]));
    	    			g.drawLine(x, y, (int) (x-dir2[0]*80*var[1]), (int) (y-dir2[1]*80*var[1]));
    				}
    			}*/
    			   			
    		}

    	} 
    	if(this.getStil().equals("histo")){
    		int[] counter = this.count;
    		int[] asso = this.association;
    		int max = BenUtil.max(counter);
    		for(int i=0;i<counter.length;i++){
    			double val = counter[i]*200/max;
    			int va = (int) val;
    			int col = this.association[i]+1;
    			g.setColor(colour[col]);
    			//System.out.println(col);
    			g.drawRect(i*10+15, 220-va, 10, va);
    			g.fillRect(i*10+15, 220-va, 10, va);
    			
    		}
    	} 
    	
    } 
   
	public static void plot(DipKM input) throws Exception{
		if(input.getDimension()!=2){
			System.out.println("Can't Plot! Dimension not 2.");
		} else {
			double[][] border = input.findBorders();
			JFrame frame = new JFrame("Sphere");
	        frame.setLocation(50, 50);
	        frame.setSize((height+200),(width+230));
	        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	        frame.add(new Paint(input,"all"));
	        frame.setVisible(true);
        }
    }
    
	public static void plot(DipKM input, String s) throws Exception{
		if(input.getDimension()!=2){
			System.out.println("Can't Plot! Dimension not 2.");
		} else {
			double[][] border = input.findBorders();
			JFrame frame = new JFrame(s);
	        frame.setLocation(50, 50);
	        frame.setSize((height+175),(width+210));
	        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	        frame.add(new Paint(input,"all"));
	        frame.setVisible(true);
        }
    }

	public static void plot(DipKM thea, int o, int p) throws Exception {
		Paint.plot( thea,  o,  p, "");
	}

	public static void plot(DipKM thea, int o, int p, String string) throws Exception {
		ArrayList<double[]> data = new ArrayList<double[]>();
		ArrayList<double[]> her = thea.getDatapoints(); 
		
		double[][] bord = thea.getBorders();
				
		for(int i=0;i<her.size();i++){
			double[] ado = new double[2];
			ado[0]=her.get(i)[o]-bord[o][0];
			ado[1]=her.get(i)[p]-bord[p][0];;
			data.add(ado);
		}
		DipKM af = new DipKM(data,thea.association());
		Paint.plot(af,string);
	}

	public static void plot(DipKM thea, int j,String s) {
		int[] counter = new int[100];
		int[] asso = thea.association();
		int[] ass = new int[100];
		double[] values = new double[thea.getDatapoints().size()];
		for(int i=0;i<values.length;i++){
			values[i]=thea.getDatapoints().get(i)[j];
		}
		double min = BenUtil.min(values);
		double max = BenUtil.max(values);
		for(int i=0;i<values.length;i++){
			int corr = (int)((values[i]-min)/(max-min)*100);
			if(corr<100){
				counter[corr]++;
				if(ass[corr]>0 && ass[corr]!=asso[i] && ass[corr]!=-1){
					ass[corr]=-1;
				} else {
					ass[corr]=asso[i];
				}
			} else {
				counter[99]++;
				ass[99]=asso[i];
			}
		}
		JFrame frame = new JFrame("Dim "+s+"-Histogram ");
        frame.setLocation(50, 50);
        frame.setSize((1050),(300));
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.add(new Paint(counter,ass,"histo"));
        frame.setVisible(true);
	}
	

	public static void plot(DipKM thea, int[] la, String s) {
		if(thea.getDimension()!=2){
			System.out.println("Can't Plot! Dimension not 2.");
		} else {
			double[][] border = thea.findBorders();
			JFrame frame = new JFrame(s);
	        frame.setLocation(50, 50);
	        frame.setSize((height+175),(width+210));
	        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	        frame.add(new Paint(thea,la));
	        frame.setVisible(true);
        }
	}
	
	public static void plot(DipKM thea, int[] lab) {
		if(thea.getDimension()!=2){
			System.out.println("Can't Plot! Dimension not 2.");
		} else {
			double[][] border = thea.findBorders();
			JFrame frame = new JFrame("co");
	        frame.setLocation(50, 50);
	        frame.setSize((height+175),(width+210));
	        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	        frame.add(new Paint(thea,lab));
	        frame.setVisible(true);
        }
	}

	public static void plotClusterPCA(DipKM thea, ArrayList<double[][]> directions, ArrayList<double[]> strength) {
		if(thea.getDimension()!=2){
			System.out.println("Can't Plot! Dimension not 2.");
		} else {
			double[][] border = thea.findBorders();
			JFrame frame = new JFrame("co");
	        frame.setLocation(50, 50);
	        frame.setSize((height+175),(width+210));
	        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	        frame.add(new Paint(thea,directions,strength));
	        frame.setVisible(true);
        }
	}




    	  

}


